module.exports = [
  {
    name: 'Getting started',
    content: 'doc-src/getting-started.md'
  },
  {
    name: 'Layout, nav and page structures',
    content: 'doc-src/layout.md',
    components: () => {
      const components = [
        'LayoutWrapper',
        'MainHeader',
        'HeaderBrand',
        'MainContentWrapper',
        'MainFooter',
        'NavBar',
        'Section',
        'Sidebar',
        'SideMenu'
      ];
      return components.map(name => `src/${name}/index.js`);
    }
  },
  {
    name: 'Form components',
    sections: [
      {
        name: 'Form',
        components: () => {
          const components = [
            'Form',
            'Form/Wrapper',
            'Form/Body',
            'Form/Footer',
            'Form/Title',
            'Form/ButtonsWrapper',
            'Fieldset'
          ];
          return components.map(name => `src/${name}/index.js`);
        }
      },
      {
        name: 'Inputs',
        components: () => {
          const components = [
            'Autocomplete',
            'CheckBox',
            'CheckBoxes',
            'FileInput',
            'ImageInput',
            'FieldControl',
            'Radio',
            'RichTextEditor',
            'SelectInput',
            'FilterBar',
            'TextArea',
            'TextInput',
            'DatepickerInput',
            'Cropper'
          ];
          return components.map(name => `src/${name}/index.js`);
        }
      }
    ]
  },
  {
    name: 'Display components',
    components: () => {
      const components = [
        'Alert',
        'Accordion',
        'Background',
        'BreadCrumb',
        'Button',
        'Cards',
        'Dropdown',
        'Icon',
        'Label',
        'Media',
        'Modal',
        'Modal/Header',
        'Modal/Body',
        'Modal/Footer',
        'Modal/Fake',
        'Pagination',
        'Progress',
        'Slideshow',
        'SortableList',
        'Spinner',
        'Stepper',
        'Table',
        'Tabs',
        'TextIcon',
        'Title',
        'Tooltip',
        'UIStates',
        'Article',
        'Collapsible'
      ];
      return components.map(name => `src/${name}/index.js`);
    }
  },
  {
    name: 'Sigfox specific components',
    components: () => {
      const components = [
        'SigfoxBrand',
        'SigfoxLogoIdSide'
      ];
      return components.map(name => `src/${name}/index.js`);
    }
  }
];
