'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _getClassName2 = require('babel-plugin-react-css-modules/dist/browser/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _styleModuleImportMap = {
  './card-section.scss': {
    'section': 'flive_card-section_section',
    'sm': 'flive_card-section_sm',
    'md': 'flive_card-section_md',
    'lg': 'flive_card-section_lg',
    'horizontal': 'flive_card-section_horizontal',
    'body--section': 'flive_card-section_body--section'
  }
};

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var CardSection = function CardSection(_ref) {
  var className = _ref.className,
      children = _ref.children,
      colorVariant = _ref.colorVariant,
      horizontal = _ref.horizontal,
      size = _ref.size,
      rest = _objectWithoutProperties(_ref, ['className', 'children', 'colorVariant', 'horizontal', 'size']);

  return _react2.default.createElement(
    'div',
    _extends({}, rest, {
      className: (className ? className + ' ' : '') + (0, _getClassName3.default)((0, _classnames2.default)('section', size, { horizontal: horizontal }), _styleModuleImportMap)
    }),
    _react2.default.Children.map(children, function (child) {
      var isValidElement = _react2.default.isValidElement(child);
      if (isValidElement && child.type.componentName === 'CardSectionBody') {
        return _react2.default.cloneElement(child, { colorVariant: colorVariant, size: size });
      } else if (isValidElement && child.type.componentName === 'CardSectionFooter') {
        return _react2.default.cloneElement(child, { colorVariant: colorVariant });
      }
      return child;
    })
  );
};

CardSection.propTypes = {
  /** @ignore */
  className: _propTypes2.default.string,
  /** @ignore */
  children: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.arrayOf(_propTypes2.default.element)]),
  colorVariant: _propTypes2.default.oneOf(['grey', 'white']),
  horizontal: _propTypes2.default.bool,
  size: _propTypes2.default.string
};

CardSection.defaultProps = {
  className: undefined,
  children: null,
  colorVariant: 'grey',
  horizontal: false,
  size: null
};

CardSection.componentName = 'CardSection';

exports.default = CardSection;
module.exports = exports['default'];