'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _getClassName2 = require('babel-plugin-react-css-modules/dist/browser/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _index = require('../FieldControl/index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _styleModuleImportMap = {
  './checkbox.scss': {
    'base': 'flive_checkbox_base',
    'toggle-switch': 'flive_checkbox_toggle-switch'
  }
};

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /* eslint-disable jsx-a11y/label-has-for, jsx-a11y/no-static-element-interactions */


function getInputProps(props) {
  var input = props.input,
      resultProps = _objectWithoutProperties(props, ['input']);

  return _extends({}, resultProps, input);
}

var propTypes = {
  optionValue: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.bool, _propTypes2.default.array, _propTypes2.default.object]),
  children: _propTypes2.default.node,
  input: _propTypes2.default.object,
  variant: _propTypes2.default.oneOf(['toggle-switch'])
};

var defaultProps = {
  input: null,
  children: null,
  variant: undefined,
  optionValue: true
};

var CheckBox = function (_React$Component) {
  _inherits(CheckBox, _React$Component);

  function CheckBox() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, CheckBox);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = CheckBox.__proto__ || Object.getPrototypeOf(CheckBox)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (event) {
      var _getInputProps = getInputProps(_this.props),
          onChange = _getInputProps.onChange,
          optionValue = _getInputProps.optionValue;

      var checked = event.target.checked;

      if (typeof onChange === 'function') {
        onChange(checked ? optionValue : false, optionValue);
      }
    }, _this.onBlur = function (event) {
      var _getInputProps2 = getInputProps(_this.props),
          onBlur = _getInputProps2.onBlur,
          optionValue = _getInputProps2.optionValue;

      var checked = event.target.checked;

      if (typeof onBlur === 'function') {
        onBlur(checked ? optionValue : false, optionValue);
      }
    }, _this.handleOnClick = function () {
      _this.input.click();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(CheckBox, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          variant = _props.variant,
          props = _objectWithoutProperties(_props, ['children', 'variant']);

      return _react2.default.createElement(
        _index2.default,
        props,
        function (restProps) {
          var resultProps = (0, _omit2.default)(getInputProps(restProps), ['id', 'type', 'checked', 'onChange', 'optionValue', 'onBlur']);
          return _react2.default.createElement(
            'div',
            {
              className: (0, _getClassName3.default)((0, _classnames2.default)('base', variant), _styleModuleImportMap)
            },
            _react2.default.createElement('input', _extends({
              ref: function ref(input) {
                _this2.input = input;
              },
              type: 'checkbox',
              onChange: _this2.onChange,
              onBlur: _this2.onBlur,
              checked: resultProps.value !== false && resultProps.value !== '' && resultProps.value !== undefined
            }, resultProps)),
            _react2.default.createElement(
              'label',
              { onClick: _this2.handleOnClick },
              children
            )
          );
        }
      );
    }
  }]);

  return CheckBox;
}(_react2.default.Component);

CheckBox.propTypes = propTypes;
CheckBox.defaultProps = defaultProps;
exports.default = CheckBox;
module.exports = exports['default'];