'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDatetime = require('react-datetime');

var _reactDatetime2 = _interopRequireDefault(_reactDatetime);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _FieldControl = require('../FieldControl');

var _FieldControl2 = _interopRequireDefault(_FieldControl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } // eslint-disable-line no-unused-vars


function getInputProps(props) {
  var input = props.input,
      resultProps = _objectWithoutProperties(props, ['input']);

  return _extends({}, resultProps, input);
}

var propTypes = {};

var defaultProps = {};

/**
 * Text Input
 *
 */

var DatepickerInput = function (_React$PureComponent) {
  _inherits(DatepickerInput, _React$PureComponent);

  function DatepickerInput() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, DatepickerInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DatepickerInput.__proto__ || Object.getPrototypeOf(DatepickerInput)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (value) {
      var _getInputProps = getInputProps(_this.props),
          onChange = _getInputProps.onChange;

      if (onChange && (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object') {
        onChange(value.toString());
      } else {
        onChange(value);
      }
    }, _this.onFocus = function () {
      var _getInputProps2 = getInputProps(_this.props),
          onFocus = _getInputProps2.onFocus,
          value = _getInputProps2.value;

      if (onFocus) {
        onFocus(value);
      }
    }, _this.onBlur = function () {
      var _getInputProps3 = getInputProps(_this.props),
          onBlur = _getInputProps3.onBlur,
          value = _getInputProps3.value;

      if (onBlur) {
        onBlur(value);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(DatepickerInput, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(
        _FieldControl2.default,
        this.props,
        function (restProps) {
          var _getInputProps4 = getInputProps(restProps),
              value = _getInputProps4.value,
              dateProps = _objectWithoutProperties(_getInputProps4, ['value']);

          var valueDate = new Date(value);
          return _react2.default.createElement(_reactDatetime2.default, _extends({
            className: 'flive_datepicker-input_input-control',
            onChange: _this2.onChange,
            onFocus: _this2.onFocus,
            onBlur: _this2.onBlur,
            dateFormat: 'YYYY/MM/DD',
            timeFormat: '',
            value: valueDate.toUTCString() === 'Invalid Date' ? value : valueDate
          }, (0, _omit2.default)(dateProps, ['onChange', 'onFocus', 'onBlur'])));
        }
      );
    }
  }]);

  return DatepickerInput;
}(_react2.default.PureComponent);

DatepickerInput.propTypes = propTypes;
DatepickerInput.defaultProps = defaultProps;
exports.default = DatepickerInput;
module.exports = exports['default'];