'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _getClassName2 = require('babel-plugin-react-css-modules/dist/browser/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _styleModuleImportMap = {
  './dropdown-item.scss': {
    'base': 'flive_dropdown-item_base',
    'simple': 'flive_dropdown-item_simple',
    'launcher': 'flive_dropdown-item_launcher'
  }
};

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Item = function Item(_ref) {
  var className = _ref.className,
      variant = _ref.variant,
      Component = _ref.component,
      closePanel = _ref.closePanel,
      _onClick = _ref.onClick,
      props = _objectWithoutProperties(_ref, ['className', 'variant', 'component', 'closePanel', 'onClick']);

  return _react2.default.createElement(Component, _extends({
    onClick: function onClick() {
      if (closePanel) closePanel();if (_onClick) _onClick();
    }
  }, props, {
    className: (className ? className + ' ' : '') + (0, _getClassName3.default)((0, _classnames2.default)('base', variant), _styleModuleImportMap)
  }));
};

Item.propTypes = {
  /** @ignore */
  className: _propTypes2.default.string,
  /** @ignore */
  onClick: _propTypes2.default.func,
  variant: _propTypes2.default.oneOf(['simple', 'launcher']),
  component: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object, _propTypes2.default.func]),
  closePanel: _propTypes2.default.func
};

Item.defaultProps = {
  className: undefined,
  variant: 'simple',
  component: 'a',
  closePanel: null,
  onClick: null
};

Item.componentName = 'Item';

exports.default = Item;
module.exports = exports['default'];