'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _getClassName2 = require('babel-plugin-react-css-modules/dist/browser/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _index = require('./Hint/index');

var _index2 = _interopRequireDefault(_index);

var _index3 = require('../Icon/index');

var _index4 = _interopRequireDefault(_index3);

var _index5 = require('../Tooltip/index');

var _index6 = _interopRequireDefault(_index5);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _styleModuleImportMap = {
  './field-control.scss': {
    'form-group': 'flive_field-control_form-group',
    'with-marge': 'flive_field-control_with-marge',
    'form-label': 'flive_field-control_form-label',
    'form-info': 'flive_field-control_form-info',
    'mandatory': 'flive_field-control_mandatory',
    'checkable': 'flive_field-control_checkable',
    'content': 'flive_field-control_content',
    'unvalid': 'flive_field-control_unvalid',
    'checkable-ok': 'flive_field-control_checkable-ok',
    'valid': 'flive_field-control_valid'
  }
};

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var formatErrorLabel = function formatErrorLabel(_ref) {
  var errorValue = _ref.errorValue,
      label = _ref.label,
      name = _ref.name;
  return errorValue.replace('"' + name + '"', '"' + label + '"');
};

var propTypes = {
  className: _propTypes2.default.string,
  label: _propTypes2.default.string,
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]),
  mandatory: _propTypes2.default.bool,
  length: _propTypes2.default.number,
  maxLength: _propTypes2.default.number,
  touched: _propTypes2.default.bool,
  error: _propTypes2.default.node,
  hint: _propTypes2.default.node,
  help: _propTypes2.default.shape({
    overlay: _propTypes2.default.string.isRequired
  }),
  meta: _propTypes2.default.object,
  input: _propTypes2.default.object,
  withoutMarge: _propTypes2.default.bool,
  formatError: _propTypes2.default.func,
  variant: _propTypes2.default.string,
  getError: _propTypes2.default.func
};

var defaultProps = {
  className: null,
  label: null,
  hint: null,
  help: null,
  children: null,
  mandatory: false,
  length: 0,
  maxLength: null,
  touched: false,
  error: null,
  meta: null,
  input: null,
  withoutMarge: false,
  formatError: formatErrorLabel,
  variant: 'primary',
  getError: null
};

var FieldControl = function FieldControl(_ref2) {
  var className = _ref2.className,
      label = _ref2.label,
      hint = _ref2.hint,
      help = _ref2.help,
      children = _ref2.children,
      mandatory = _ref2.mandatory,
      maxLength = _ref2.maxLength,
      length = _ref2.length,
      meta = _ref2.meta,
      withoutMarge = _ref2.withoutMarge,
      formatError = _ref2.formatError,
      variant = _ref2.variant,
      getError = _ref2.getError,
      props = _objectWithoutProperties(_ref2, ['className', 'label', 'hint', 'help', 'children', 'mandatory', 'maxLength', 'length', 'meta', 'withoutMarge', 'formatError', 'variant', 'getError']);

  var _ref3 = meta || props,
      error = _ref3.error,
      touched = _ref3.touched;

  var _ref4 = props.input || props,
      name = _ref4.name;

  var content = typeof children === 'function' ? children((0, _omit2.default)(props, ['error', 'touched'])) : children;
  var checkableVariant = variant === 'checkable';
  var errorValue = error || (getError ? getError(props) : null);
  var errorIsText = typeof errorValue === 'string';
  var contentNode = checkableVariant ? _react2.default.createElement(
    'div',
    {
      className: (0, _getClassName3.default)((0, _classnames2.default)(variant, { 'checkable-ok': !errorValue && checkableVariant }), _styleModuleImportMap)
    },
    _react2.default.createElement(
      'div',
      {
        className: (0, _getClassName3.default)((0, _classnames2.default)('content'), _styleModuleImportMap)
      },
      content
    )
  ) : content;
  return _react2.default.createElement(
    'div',
    {
      className: (className ? className + ' ' : '') + (0, _getClassName3.default)((0, _classnames2.default)('form-group', { 'with-marge': !withoutMarge }), _styleModuleImportMap)
    },
    label && _react2.default.createElement(
      'div',
      { className: 'flive_field-control_form-info' },
      _react2.default.createElement(
        'span',
        { className: 'flive_field-control_form-label' },
        label,
        mandatory && _react2.default.createElement(
          'span',
          { className: 'flive_field-control_mandatory' },
          '*'
        )
      ),
      help && _react2.default.createElement(
        _index6.default,
        help,
        _react2.default.createElement(_index4.default, { size: 'xs', name: 'help-circled' })
      )
    ),
    contentNode,
    touched && !!errorValue && errorIsText && _react2.default.createElement(
      _index2.default,
      { variant: 'danger' },
      formatError(_extends({}, props, { name: name, label: label, errorValue: errorValue }))
    ),
    !!maxLength && _react2.default.createElement(
      _index2.default,
      null,
      'Content length :',
      ' ',
      _react2.default.createElement(
        _index2.default,
        { component: 'span', variant: length <= maxLength ? 'success' : 'danger' },
        length
      ),
      ' / ',
      maxLength,
      ' (Max. length)'
    ),
    !!hint && _react2.default.createElement(
      _index2.default,
      null,
      hint
    )
  );
};

FieldControl.propTypes = propTypes;
FieldControl.defaultProps = defaultProps;

exports.default = FieldControl;
module.exports = exports['default'];