'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TextIcon = require('../../TextIcon');

var _TextIcon2 = _interopRequireDefault(_TextIcon);

var _Button = require('../../Button');

var _Button2 = _interopRequireDefault(_Button);

var _Icon = require('../../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Modal = require('../../Modal');

var _Modal2 = _interopRequireDefault(_Modal);

var _TextInput = require('../../TextInput');

var _TextInput2 = _interopRequireDefault(_TextInput);

var _Hint = require('../../FieldControl/Hint');

var _Hint2 = _interopRequireDefault(_Hint);

var _Progress = require('../../Progress');

var _Progress2 = _interopRequireDefault(_Progress);

var _Spinner = require('../../Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Header = _Modal2.default.Header,
    Body = _Modal2.default.Body,
    Footer = _Modal2.default.Footer;


var propTypes = {
  value: _propTypes2.default.PropTypes.arrayOf(_propTypes2.default.shape({
    name: _propTypes2.default.string,
    preview: _propTypes2.default.string,
    loading: _propTypes2.default.bool
  })).isRequired,
  handleDelete: _propTypes2.default.func,
  handleEdit: _propTypes2.default.func,
  customModalEdit: _propTypes2.default.bool,
  children: _propTypes2.default.node,
  allowDelete: _propTypes2.default.bool,
  allowEdit: _propTypes2.default.bool
};

var defaultProps = {
  handleDelete: undefined,
  handleEdit: undefined,
  customModalEdit: false,
  children: undefined,
  allowDelete: true,
  allowEdit: true
};

var ListFile = function (_Component) {
  _inherits(ListFile, _Component);

  function ListFile() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ListFile);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ListFile.__proto__ || Object.getPrototypeOf(ListFile)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      fileEditRow: false,
      fileName: ''
    }, _this.handlerDelete = function (file, row) {
      return function () {
        var handleDelete = _this.props.handleDelete;

        if (handleDelete) {
          handleDelete(file, row);
        }
      };
    }, _this.handlerEdit = function (file, row) {
      return function () {
        var _this$props = _this.props,
            handleEdit = _this$props.handleEdit,
            customModalEdit = _this$props.customModalEdit;

        if (!handleEdit) return;
        if (customModalEdit) {
          handleEdit(file, row);
        } else {
          _this.setState({
            fileEditRow: row,
            fileName: file.name
          });
        }
      };
    }, _this.handleFileNameChange = function () {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref2$target = _ref2.target,
          target = _ref2$target === undefined ? {} : _ref2$target;

      return _this.setState({ fileName: target.value });
    }, _this.handleCloseModal = function () {
      return _this.setState({ fileEditRow: false, fileName: '' });
    }, _this.handleValidName = function () {
      var _this$props2 = _this.props,
          value = _this$props2.value,
          handleEdit = _this$props2.handleEdit;
      var _this$state = _this.state,
          fileEditRow = _this$state.fileEditRow,
          fileName = _this$state.fileName;

      if (handleEdit) {
        var file = value.find(function (item, row) {
          return fileEditRow === row;
        });
        handleEdit(_extends({}, file, { name: fileName }), fileEditRow);
      }
      _this.setState({ fileEditRow: false, fileName: '' });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ListFile, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          value = _props.value,
          allowDelete = _props.allowDelete,
          allowEdit = _props.allowEdit,
          children = _props.children;
      var _state = this.state,
          fileEditRow = _state.fileEditRow,
          fileName = _state.fileName;

      return _react2.default.createElement(
        'div',
        { className: 'flive_list-file_base' },
        value.map(function (file, row) {
          var status = file.status,
              key = file.key,
              preview = file.preview,
              name = file.name,
              progress = file.progress,
              progressBar = file.progressBar;

          if (status === 'pending') {
            return progressBar ? _react2.default.createElement(_Progress2.default, { className: 'flive_list-file_progress-bar', value: progress }) : _react2.default.createElement(_Spinner2.default, null);
          }
          return _react2.default.createElement(
            'div',
            { className: 'flive_list-file_content', key: key || preview },
            _react2.default.createElement(
              _TextIcon2.default,
              { name: 'doc', size: 'sm' },
              name,
              allowDelete && _react2.default.createElement(
                _Button2.default,
                {
                  onClick: _this2.handlerDelete(file, row),
                  type: 'button',
                  className: 'flive_list-file_button-trash',
                  variant: 'icon',
                  size: 'sm'
                },
                _react2.default.createElement(_Icon2.default, { name: 'trash', size: 'xs' })
              ),
              allowEdit && _react2.default.createElement(
                _Button2.default,
                {
                  onClick: _this2.handlerEdit(file, row),
                  type: 'button',
                  className: 'flive_list-file_button-trash',
                  variant: 'icon',
                  size: 'sm'
                },
                _react2.default.createElement(_Icon2.default, { name: 'edit', size: 'xs' })
              )
            ),
            status === 'error' && _react2.default.createElement(
              _Hint2.default,
              { variant: 'danger' },
              'Something went wrong, please try again.'
            )
          );
        }),
        children,
        fileEditRow !== false && _react2.default.createElement(
          _Modal2.default,
          { isOpen: true, size: 'sm' },
          _react2.default.createElement(
            Header,
            { onClose: this.handleCloseModal },
            'Edit file name'
          ),
          _react2.default.createElement(
            Body,
            null,
            _react2.default.createElement(_TextInput2.default, {
              value: fileName,
              onChange: this.handleFileNameChange
            })
          ),
          _react2.default.createElement(
            Footer,
            null,
            _react2.default.createElement(
              _Button2.default,
              { type: 'button', onClick: this.handleValidName },
              'Ok'
            ),
            _react2.default.createElement(
              _Button2.default,
              {
                type: 'button',
                variant: 'cancel',
                onClick: this.handleCloseModal
              },
              'Cancel'
            )
          )
        )
      );
    }
  }]);

  return ListFile;
}(_react.Component);

ListFile.propTypes = propTypes;
ListFile.defaultProps = defaultProps;

exports.default = ListFile;
module.exports = exports['default'];