'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDropzone = require('react-dropzone');

var _reactDropzone2 = _interopRequireDefault(_reactDropzone);

var _uniqid = require('uniqid');

var _uniqid2 = _interopRequireDefault(_uniqid);

var _warning = require('warning');

var _warning2 = _interopRequireDefault(_warning);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _slugify = require('slugify');

var _slugify2 = _interopRequireDefault(_slugify);

var _FieldControl = require('../FieldControl');

var _FieldControl2 = _interopRequireDefault(_FieldControl);

var _Alert = require('../Alert');

var _Alert2 = _interopRequireDefault(_Alert);

var _ListFiles = require('./ListFiles');

var _ListFiles2 = _interopRequireDefault(_ListFiles);

var _tools = require('../_helpers/tools');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  className: _propTypes2.default.string,
  formName: _propTypes2.default.string,
  children: _propTypes2.default.func,
  fileRequest: _propTypes2.default.func.isRequired,
  originalFileRequest: _propTypes2.default.func.isRequired,
  onProgress: _propTypes2.default.func,
  onDrop: _propTypes2.default.func,
  onDelete: _propTypes2.default.func,
  proxyGetValue: _propTypes2.default.func,
  proxyChangeValue: _propTypes2.default.func,
  accept: _propTypes2.default.string,
  maxSize: _propTypes2.default.number,
  minSize: _propTypes2.default.number,
  maxFiles: _propTypes2.default.number,
  input: _propTypes2.default.object,
  label: _propTypes2.default.string,
  mandatory: _propTypes2.default.bool,
  multiple: _propTypes2.default.bool,
  placeHolder: _propTypes2.default.string,
  autoUpload: _propTypes2.default.bool,
  progressBar: _propTypes2.default.bool,
  allowDelete: _propTypes2.default.bool,
  allowEdit: _propTypes2.default.bool
};

var defaultProps = {
  className: null,
  formName: 'default',
  children: undefined,
  fileRequest: function fileRequest() {},
  originalFileRequest: function originalFileRequest() {},
  onDrop: undefined,
  onDelete: undefined,
  proxyGetValue: undefined,
  proxyChangeValue: undefined,
  onProgress: undefined,
  accept: undefined,
  maxSize: Infinity,
  minSize: 0,
  maxFiles: null,
  input: null,
  label: null,
  mandatory: false,
  multiple: false,
  placeHolder: null,
  autoUpload: false,
  progressBar: false,
  allowEdit: true,
  allowDelete: true
};

var getFileInputProps = function getFileInputProps(initialProps) {
  var proxyGetValue = initialProps.proxyGetValue;

  var props = (0, _tools.getInputProps)(initialProps);
  if (typeof proxyGetValue === 'function') {
    props.value = proxyGetValue(initialProps);
  } else if (props.value && !Array.isArray(props.value)) {
    props.value = [props.value];
  }
  return props;
};

var changeValue = function changeValue(_ref) {
  var value = _ref.value,
      props = _ref.props;
  var multiple = props.multiple,
      maxFiles = props.maxFiles,
      proxyChangeValue = props.proxyChangeValue;

  if (typeof proxyChangeValue === 'function') {
    return proxyChangeValue({ value: value, props: props });
  }

  var _getFileInputProps = getFileInputProps(props),
      onChange = _getFileInputProps.onChange;

  if (onChange) {
    if (!multiple) return onChange(value[0] || null);
    onChange(maxFiles ? value.slice(0, maxFiles) : value);
  }
};

var FileInput = function (_Component) {
  _inherits(FileInput, _Component);

  function FileInput() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, FileInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = FileInput.__proto__ || Object.getPrototypeOf(FileInput)).call.apply(_ref2, [this].concat(args))), _this), _this.getInputProps = function (customProps) {
      return getFileInputProps(customProps || _this.props);
    }, _this.changeValue = function (value) {
      return changeValue({ value: value, props: _this.props });
    }, _this.handleDelete = function (file, row) {
      var onDelete = _this.props.onDelete;

      var _this$getInputProps = _this.getInputProps(),
          _this$getInputProps$v = _toArray(_this$getInputProps.value),
          value = _this$getInputProps$v.slice(0);

      value.splice(row, 1);
      if (onDelete) onDelete(value);
      _this.changeValue(value);
    }, _this.handleEdit = function (file, row) {
      var _this$getInputProps2 = _this.getInputProps(),
          _this$getInputProps2$ = _toArray(_this$getInputProps2.value),
          value = _this$getInputProps2$.slice(0);

      value[row] = file;
      _this.changeValue(value);
    }, _this.handleDrop = function (files) {
      var _this$props = _this.props,
          onDrop = _this$props.onDrop,
          multiple = _this$props.multiple,
          autoUpload = _this$props.autoUpload,
          maxFiles = _this$props.maxFiles,
          progressBar = _this$props.progressBar;

      var _this$getInputProps3 = _this.getInputProps(),
          _this$getInputProps3$ = _this$getInputProps3.value,
          value = _this$getInputProps3$ === undefined ? [] : _this$getInputProps3$;

      var filteredFiles = files;
      if (maxFiles) {
        if (value.length >= maxFiles) return;
        filteredFiles = files.slice(0, maxFiles - value.length);
      }
      var filesToUpload = filteredFiles.map(function (file, row) {
        var initialName = file.name,
            type = file.type,
            preview = file.preview;

        var splitName = initialName.split('.');
        var fileType = splitName.pop();
        var name = splitName.join('.');
        var hashName = (0, _uniqid2.default)() + '-' + (0, _slugify2.default)(name) + '.' + fileType;
        var resultFile = {
          hashName: hashName,
          file: file,
          name: name,
          type: type,
          preview: preview,
          progressBar: progressBar,
          status: 'waiting'
        };
        if (autoUpload) {
          resultFile = _this.submitFile(resultFile, row);
        }
        return resultFile;
      });
      if (filesToUpload.length) {
        _this.changeValue(multiple ? [].concat(_toConsumableArray(filesToUpload), _toConsumableArray(value)) : filesToUpload);
      }
      if (onDrop && filesToUpload.length) {
        onDrop(filesToUpload, _this.handleSubmitFiles);
      }
    }, _this.handleSubmitFiles = function (filesToUpload) {
      var _this$getInputProps4 = _this.getInputProps(),
          _this$getInputProps4$ = _this$getInputProps4.value,
          value = _this$getInputProps4$ === undefined ? [] : _this$getInputProps4$;

      var resultValue = value.map(function (fileObject, row) {
        var selectedFile = filesToUpload.find(function (_ref3) {
          var hashName = _ref3.hashName,
              status = _ref3.status;
          return hashName && hashName === fileObject.hashName && status === 'waiting';
        });
        if (selectedFile) {
          return _this.submitFile(fileObject, row);
        }
        return fileObject;
      });
      _this.changeValue(resultValue);
    }, _this.submitFile = function (fileToUpload, row) {
      var _this$props2 = _this.props,
          fileRequest = _this$props2.fileRequest,
          _this$props2$original = _this$props2.originalFileRequest,
          originalFileRequest = _this$props2$original === undefined ? _this.props.fileRequest : _this$props2$original;
      var file = fileToUpload.file,
          originalFile = fileToUpload.originalFile;

      var data = new FormData();
      data.append('file', file);
      var request = fileRequest(_extends({}, fileToUpload, { data: data }), function (progress) {
        return _this.handleProgress({ progress: progress, file: file });
      });
      if (!request || typeof request.then !== 'function') {
        (0, _warning2.default)(false, '"uploadFiles" function need return promise');
        return _extends({}, fileToUpload, { status: 'error' });
      }
      var requests = [request];
      if (originalFile) {
        var originalData = new FormData();
        originalData.append('file', originalFile);
        var originalRequest = originalFileRequest(_extends({}, fileToUpload, {
          data: originalData
        }));
        if (!originalRequest || typeof originalRequest.then !== 'function') {
          (0, _warning2.default)(false, '"uploadFiles" function need return promise');
          return _extends({}, fileToUpload, { status: 'error' });
        }
        requests.push(originalRequest);
      }

      Promise.all(requests).then(function (_ref4) {
        var _ref5 = _slicedToArray(_ref4, 2),
            fileResp = _ref5[0],
            originalFileResp = _ref5[1];

        return _this.submitFileSuccess({ fileResp: fileResp, originalFileResp: originalFileResp, fileToUpload: fileToUpload });
      }).catch(function (error) {
        return _this.submitFileError({ error: error, fileToUpload: fileToUpload, row: row });
      });
      return _extends({}, fileToUpload, { request: request, status: 'pending', progress: 0 });
    }, _this.handleProgress = function (_ref6) {
      var progress = _ref6.progress,
          file = _ref6.file;

      var _this$getInputProps5 = _this.getInputProps(),
          _this$getInputProps5$ = _this$getInputProps5.value,
          value = _this$getInputProps5$ === undefined ? [] : _this$getInputProps5$;

      var result = value.map(function (fileToUpload) {
        if (file === fileToUpload.file) {
          return _extends({}, fileToUpload, { progress: progress });
        }
        return fileToUpload;
      });
      _this.changeValue(result);
    }, _this.submitFileSuccess = function (_ref7) {
      var _ref7$fileResp = _ref7.fileResp,
          fileResp = _ref7$fileResp === undefined ? {} : _ref7$fileResp,
          _ref7$originalFileRes = _ref7.originalFileResp,
          originalFileResp = _ref7$originalFileRes === undefined ? {} : _ref7$originalFileRes,
          hashName = _ref7.fileToUpload.hashName;

      var _this$getInputProps6 = _this.getInputProps(),
          _this$getInputProps6$ = _this$getInputProps6.value,
          value = _this$getInputProps6$ === undefined ? [] : _this$getInputProps6$;

      var fileRespData = fileResp.data;
      var originalFileRespData = originalFileResp.data;

      var resultValue = value.map(function (fileObject) {
        if (!hashName || hashName !== fileObject.hashName) return fileObject;
        var path = fileRespData.path,
            _fileRespData$type = fileRespData.type,
            type = _fileRespData$type === undefined ? fileObject.type : _fileRespData$type;

        var filteredFilObject = (0, _omit2.default)(fileObject, ['file', 'originalFile', 'preview', 'progress', 'status', 'request']);
        if (originalFileRespData || fileObject.originalPath) {
          var _ref8 = originalFileRespData || {},
              _ref8$path = _ref8.path,
              originalPath = _ref8$path === undefined ? fileObject.originalPath : _ref8$path,
              _ref8$type = _ref8.type,
              originalType = _ref8$type === undefined ? fileObject.originalType : _ref8$type;

          return _extends({}, filteredFilObject, {
            path: path,
            type: type,
            originalPath: originalPath,
            originalType: originalType
          });
        }
        return _extends({}, filteredFilObject, {
          path: path,
          type: type
        });
      });
      _this.changeValue(resultValue);
    }, _this.submitFileError = function (_ref9) {
      var error = _ref9.error,
          row = _ref9.row;

      var _this$getInputProps7 = _this.getInputProps(),
          _this$getInputProps7$ = _this$getInputProps7.value,
          value = _this$getInputProps7$ === undefined ? [] : _this$getInputProps7$;

      var resultValue = value.map(function (fileObject, fileRow) {
        if (row !== fileRow) return fileObject;
        return _extends({}, (0, _omit2.default)(fileObject, ['file', 'originalFile', 'preview', 'progress', 'status', 'request']), {
          status: 'error',
          error: error
        });
      });
      _this.changeValue(resultValue);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(FileInput, [{
    key: 'renderWithoutChild',
    value: function renderWithoutChild() {
      var _getInputProps = this.getInputProps(),
          value = _getInputProps.value;

      return value && !!value.length && _react2.default.createElement(_ListFiles2.default, {
        key: 'list-files',
        value: value,
        handleDelete: this.handleDelete,
        handleEdit: this.handleEdit,
        allowDelete: this.props.allowDelete,
        allowEdit: this.props.allowEdit
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          multiple = _props.multiple,
          maxSize = _props.maxSize,
          minSize = _props.minSize,
          maxFiles = _props.maxFiles,
          accept = _props.accept,
          placeHolder = _props.placeHolder,
          props = _objectWithoutProperties(_props, ['children', 'multiple', 'maxSize', 'minSize', 'maxFiles', 'accept', 'placeHolder']);

      var _getInputProps2 = this.getInputProps(),
          _getInputProps2$value = _getInputProps2.value,
          value = _getInputProps2$value === undefined ? [] : _getInputProps2$value;

      return _react2.default.createElement(
        _FieldControl2.default,
        props,
        function (_ref10) {
          var restProps = _objectWithoutProperties(_ref10, []);

          var _getInputProps3 = _this2.getInputProps(restProps),
              name = _getInputProps3.name;

          return [_react2.default.createElement(
            _reactDropzone2.default,
            {
              name: name,
              onDrop: _this2.handleDrop,
              className: 'flive_file-input_drop-zone',
              multiple: multiple,
              maxSize: maxSize,
              minSize: minSize,
              accept: accept,
              key: 'drop-zone'
            },
            function (_ref11) {
              var isDragActive = _ref11.isDragActive,
                  isDragReject = _ref11.isDragReject;

              var dropWording = void 0;
              switch (true) {
                case isDragActive && maxFiles && value.length >= maxFiles:
                  dropWording = _react2.default.createElement(
                    _Alert2.default,
                    { type: 'warning' },
                    'The maximum files is exceed'
                  );
                  break;
                case isDragReject:
                  dropWording = _react2.default.createElement(
                    _Alert2.default,
                    { type: 'warning' },
                    'This file is not authorized'
                  );
                  break;
                case isDragActive:
                  dropWording = _react2.default.createElement(
                    _Alert2.default,
                    { type: 'info' },
                    'This file is authorized'
                  );
                  break;
                default:
                  dropWording = _react2.default.createElement(
                    'p',
                    { className: 'flive_file-input_placeholder' },
                    ' ',
                    placeHolder || 'You can drop your file(s) here'
                  );
              }

              return _react2.default.createElement(
                'div',
                { key: 'files-zone' },
                dropWording
              );
            }
          ), children ? _react2.default.createElement(
            'div',
            { key: 'children' },
            children(_extends({}, _this2.getInputProps(restProps), {
              handleSubmitFiles: _this2.handleSubmitFiles,
              handleDelete: _this2.handleDelete
            }))
          ) : _this2.renderWithoutChild()];
        }
      );
    }
  }]);

  return FileInput;
}(_react.Component);

FileInput.propTypes = propTypes;
FileInput.defaultProps = defaultProps;

FileInput.ListFiles = _ListFiles2.default;
FileInput.changeValue = changeValue;
FileInput.getFileInputProps = getFileInputProps;

exports.default = FileInput;
module.exports = exports['default'];