'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactSelect = require('react-select');

var _reactSelect2 = _interopRequireDefault(_reactSelect);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FilterBar = function (_Component) {
  _inherits(FilterBar, _Component);

  function FilterBar() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, FilterBar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FilterBar.__proto__ || Object.getPrototypeOf(FilterBar)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      incompleteFilter: null
    }, _this.getOptions = function () {
      var baseOptions = _this.props.baseOptions;
      var incompleteFilter = _this.state.incompleteFilter;

      if (!incompleteFilter) return baseOptions;
      var baseOption = baseOptions.find(function (o) {
        return o.value === incompleteFilter.value;
      });
      return baseOption.subOptions || [];
    }, _this.handleFilterChange = function (select) {
      var _reverse = [].concat(_toConsumableArray(select)).reverse(),
          _reverse2 = _toArray(_reverse),
          lastSelect = _reverse2[0],
          beforeLastSelect = _reverse2[1],
          rest = _reverse2.slice(2);

      // User hitted delete button/key and either
      // there is no option remaining,
      // or last selected item is a final option (already merged).


      if (!select.length || lastSelect.prop) {
        _this.setState({ incompleteFilter: null });
        return _this.props.onChange(_this.formatOutput(select));
      }

      // Last selected item is a base option.
      if (lastSelect.subOptions) {
        // This base option need to ansynchronously load his sub options.
        if (lastSelect.loadSubOptions) {
          lastSelect.loadSubOptions();
        }
        // Do not call onChange since it's an intermediary state.
        return _this.setState({
          incompleteFilter: _extends({}, lastSelect, { label: lastSelect.label + ':' })
        });
      }

      // Last selected item is a sub option and beforeLastSelect is a base option.
      // Merge base option with sub option to form one final otpion.
      var newSelect = [].concat(_toConsumableArray(_this.props.allowMultipleSameProp ? rest : rest.filter(function (o) {
        return o.prop !== beforeLastSelect.value;
      })), [{
        prop: beforeLastSelect.value,
        value: lastSelect.value,
        label: beforeLastSelect.label + ' ' + lastSelect.label
      }]);
      _this.setState({ incompleteFilter: null });
      _this.props.onChange(_this.formatOutput(newSelect));
    }, _this.handleFilterInputChange = function (input) {
      var incompleteFilter = _this.state.incompleteFilter;

      if (incompleteFilter && incompleteFilter.loadSubOptions) {
        incompleteFilter.loadSubOptions(input);
      }
      return input;
    }, _this.findLabel = function (filter) {
      var baseOptions = _this.props.baseOptions;

      var baseOption = baseOptions.find(function (_ref2) {
        var value = _ref2.value;
        return value === filter.prop;
      });
      if (!baseOption) return '';
      var subOption = baseOption.subOptions.find(function (_ref3) {
        var value = _ref3.value;
        return value === filter.value;
      }) || {};
      return baseOption.label + ': ' + (subOption.label || filter.value);
    }, _this.formatOutput = function (filters) {
      return filters.reduce(function (acc, filter) {
        if (acc[filter.prop]) {
          var currentValue = Array.isArray(acc[filter.prop]) ? acc[filter.prop] : [acc[filter.prop]];
          return _extends({}, acc, _defineProperty({}, filter.prop, [].concat(_toConsumableArray(currentValue), [filter.value])));
        }
        return _extends({}, acc, _defineProperty({}, filter.prop, filter.value));
      }, {});
    }, _this.formatInput = function (filters) {
      return Object.entries(filters).reduce(function (acc, _ref4) {
        var _ref5 = _slicedToArray(_ref4, 2),
            prop = _ref5[0],
            values = _ref5[1];

        if (Array.isArray(values)) {
          return [].concat(_toConsumableArray(acc), _toConsumableArray(values.map(function (value) {
            return {
              prop: prop,
              value: value,
              label: _this.findLabel({ prop: prop, value: value })
            };
          })));
        }
        return [].concat(_toConsumableArray(acc), [{
          prop: prop,
          value: values,
          label: _this.findLabel({ prop: prop, value: values })
        }]);
      }, []);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(FilterBar, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          placeholder = _props.placeholder;
      var incompleteFilter = this.state.incompleteFilter;

      var formattedValue = this.formatInput(value);
      return _react2.default.createElement(_reactSelect2.default, {
        className: 'flive_filter-bar_filter',
        multi: true,
        placeholder: placeholder,
        value: incompleteFilter ? [].concat(_toConsumableArray(formattedValue), [incompleteFilter]) : formattedValue,
        options: this.getOptions(),
        onChange: this.handleFilterChange,
        onInputChange: this.handleFilterInputChange
      });
    }
  }]);

  return FilterBar;
}(_react.Component);

FilterBar.propTypes = {
  /**
   * Input value.
   * Exemples: {}, { country: 'fr' }, { roles: [1, 2, 3] }
   */
  value: _propTypes2.default.object.isRequired,
  /**
   * Each options has to contain sub options and optionaly
   * a loadSubOptions() function to update them.
   */
  baseOptions: _propTypes2.default.array.isRequired,
  /**
   * Takes the filters (Array) as sole argument.
   */
  onChange: _propTypes2.default.func.isRequired,
  /**
   * Allow end user to select multiple times the same
   * base option but with a different sub otpion.
   */
  allowMultipleSameProp: _propTypes2.default.bool,
  placeholder: _propTypes2.default.string
};
FilterBar.defaultProps = {
  allowMultipleSameProp: false,
  placeholder: 'Filter...'
};
exports.default = FilterBar;
module.exports = exports['default'];