'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// eslint-disable-line no-unused-vars


/**
 * Brand / Logo bloc, to be used inside of the MainHeader
 */
var HeaderBrand = function (_PureComponent) {
  _inherits(HeaderBrand, _PureComponent);

  function HeaderBrand() {
    _classCallCheck(this, HeaderBrand);

    return _possibleConstructorReturn(this, (HeaderBrand.__proto__ || Object.getPrototypeOf(HeaderBrand)).apply(this, arguments));
  }

  _createClass(HeaderBrand, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          name = _props.name,
          logoSmall = _props.logoSmall,
          logoFull = _props.logoFull,
          className = _props.className;

      return _react2.default.createElement(
        'div',
        { className: (className ? className + ' ' : '') + 'flive_header-brand_container' },
        logoSmall && _react2.default.createElement('img', { className: 'flive_header-brand_logo-small', src: logoSmall, alt: 'logo' }),
        (logoFull || logoSmall) && _react2.default.createElement('img', { className: 'flive_header-brand_logo-full', src: logoFull || logoSmall, alt: 'logo' }),
        name && _react2.default.createElement(
          'span',
          { className: 'flive_header-brand_name' },
          name
        )
      );
    }
  }]);

  return HeaderBrand;
}(_react.PureComponent);

HeaderBrand.propTypes = {
  /** The name of your app to display next to the logo */
  name: _propTypes2.default.string,
  /** small / square version of the app logo displayed instead of the full logo on mobile resolution */
  logoSmall: _propTypes2.default.string,
  /** Full logo to be displayed on desktop resolutions. If null, logoSmall will be used */
  logoFull: _propTypes2.default.string,
  /** @ignore */
  className: _propTypes2.default.string
};
HeaderBrand.defaultProps = {
  name: null,
  logoSmall: null,
  logoFull: null,
  className: undefined
};
exports.default = HeaderBrand;
module.exports = exports['default'];