'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _getClassName2 = require('babel-plugin-react-css-modules/dist/browser/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Background = require('../Background');

var _Background2 = _interopRequireDefault(_Background);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _styleModuleImportMap = {
  './icon.scss': {
    'icon-xs': 'flive_icon_icon-xs',
    'icon-sm': 'flive_icon_icon-sm',
    'icon-md': 'flive_icon_icon-md',
    'icon-lg': 'flive_icon_icon-lg',
    'icon-auto': 'flive_icon_icon-auto',
    'circle': 'flive_icon_circle',
    'circle-xs': 'flive_icon_circle-xs',
    'circle-sm': 'flive_icon_circle-sm',
    'circle-md': 'flive_icon_circle-md',
    'circle-lg': 'flive_icon_circle-lg',
    'circle-auto': 'flive_icon_circle-auto',
    'circle-wrapper': 'flive_icon_circle-wrapper',
    'icon': 'flive_icon_icon',
    'icon-doc': 'flive_icon_icon-doc',
    'icon-app-launcher': 'flive_icon_icon-app-launcher',
    'icon-sigfox': 'flive_icon_icon-sigfox',
    'icon-trash': 'flive_icon_icon-trash',
    'icon-certification': 'flive_icon_icon-certification',
    'icon-eye': 'flive_icon_icon-eye',
    'icon-eye-off': 'flive_icon_icon-eye-off',
    'icon-ok-circle': 'flive_icon_icon-ok-circle',
    'icon-world': 'flive_icon_icon-world',
    'icon-ok-ellipsis': 'flive_icon_icon-ok-ellipsis',
    'icon-attach': 'flive_icon_icon-attach',
    'icon-link': 'flive_icon_icon-link',
    'icon-briefcase': 'flive_icon_icon-briefcase',
    'icon-sdr-dongle': 'flive_icon_icon-sdr-dongle',
    'icon-technical-quickstart': 'flive_icon_icon-technical-quickstart',
    'icon-mail': 'flive_icon_icon-mail',
    'icon-location': 'flive_icon_icon-location',
    'icon-resize-cover': 'flive_icon_icon-resize-cover',
    'icon-resize-contain': 'flive_icon_icon-resize-contain',
    'icon-search': 'flive_icon_icon-search',
    'icon-phone': 'flive_icon_icon-phone',
    'icon-signal': 'flive_icon_icon-signal',
    'icon-certificate-outline': 'flive_icon_icon-certificate-outline',
    'icon-derived-device': 'flive_icon_icon-derived-device',
    'icon-integrator': 'flive_icon_icon-integrator',
    'icon-chat': 'flive_icon_icon-chat',
    'icon-soc': 'flive_icon_icon-soc',
    'icon-software-partner': 'flive_icon_icon-software-partner',
    'icon-export': 'flive_icon_icon-export',
    'icon-kit-maker': 'flive_icon_icon-kit-maker',
    'icon-solution': 'flive_icon_icon-solution',
    'icon-solution-provider': 'flive_icon_icon-solution-provider',
    'icon-kit': 'flive_icon_icon-kit',
    'icon-help-circled': 'flive_icon_icon-help-circled',
    'icon-chip-maker': 'flive_icon_icon-chip-maker',
    'icon-manufacturer': 'flive_icon_icon-manufacturer',
    'icon-tech-hub': 'flive_icon_icon-tech-hub',
    'icon-transceiver': 'flive_icon_icon-transceiver',
    'icon-consulting-company': 'flive_icon_icon-consulting-company',
    'icon-consulting': 'flive_icon_icon-consulting',
    'icon-module-maker': 'flive_icon_icon-module-maker',
    'icon-utilities': 'flive_icon_icon-utilities',
    'icon-module': 'flive_icon_icon-module',
    'icon-na': 'flive_icon_icon-na',
    'icon-contact': 'flive_icon_icon-contact',
    'icon-design-house': 'flive_icon_icon-design-house',
    'icon-bat2': 'flive_icon_icon-bat2',
    'icon-platform-provider': 'flive_icon_icon-platform-provider',
    'icon-platform': 'flive_icon_icon-platform',
    'icon-device-maker': 'flive_icon_icon-device-maker',
    'icon-design': 'flive_icon_icon-design',
    'icon-device': 'flive_icon_icon-device',
    'icon-bat1': 'flive_icon_icon-bat1',
    'icon-bat3': 'flive_icon_icon-bat3',
    'icon-bat4': 'flive_icon_icon-bat4',
    'icon-logout': 'flive_icon_icon-logout',
    'icon-target': 'flive_icon_icon-target',
    'icon-distributor': 'flive_icon_icon-distributor',
    'icon-attention': 'flive_icon_icon-attention',
    'icon-mcu': 'flive_icon_icon-mcu',
    'icon-microchip': 'flive_icon_icon-microchip',
    'icon-external-link': 'flive_icon_icon-external-link',
    'icon-plus': 'flive_icon_icon-plus',
    'icon-webhook': 'flive_icon_icon-webhook',
    'icon-service': 'flive_icon_icon-service',
    'icon-arrows-cw': 'flive_icon_icon-arrows-cw',
    'icon-trophy': 'flive_icon_icon-trophy',
    'icon-award': 'flive_icon_icon-award',
    'icon-edit': 'flive_icon_icon-edit',
    'icon-development': 'flive_icon_icon-development',
    'icon-industrialization': 'flive_icon_icon-industrialization',
    'icon-library': 'flive_icon_icon-library',
    'icon-start': 'flive_icon_icon-start',
    'icon-study': 'flive_icon_icon-study',
    'icon-antenna': 'flive_icon_icon-antenna',
    'icon-led': 'flive_icon_icon-led',
    'icon-down': 'flive_icon_icon-down',
    'icon-left': 'flive_icon_icon-left',
    'icon-right': 'flive_icon_icon-right',
    'icon-up': 'flive_icon_icon-up',
    'icon-resize-full': 'flive_icon_icon-resize-full',
    'icon-resize-small': 'flive_icon_icon-resize-small',
    'icon-account': 'flive_icon_icon-account',
    'icon-basket': 'flive_icon_icon-basket',
    'icon-card': 'flive_icon_icon-card',
    'icon-antenna-designer': 'flive_icon_icon-antenna-designer',
    'icon-refdesign': 'flive_icon_icon-refdesign',
    'icon-wrench': 'flive_icon_icon-wrench',
    'icon-sigfox-operator': 'flive_icon_icon-sigfox-operator',
    'icon-test-house': 'flive_icon_icon-test-house',
    'icon-security-expert': 'flive_icon_icon-security-expert',
    'icon-secure-element': 'flive_icon_icon-secure-element',
    'icon-company': 'flive_icon_icon-company',
    'icon-cloud-platform-provider': 'flive_icon_icon-cloud-platform-provider',
    'icon-different-device': 'flive_icon_icon-different-device',
    'icon-cloud-platform': 'flive_icon_icon-cloud-platform',
    'icon-similar-device': 'flive_icon_icon-similar-device',
    'icon-new-device': 'flive_icon_icon-new-device',
    'icon-several-devices': 'flive_icon_icon-several-devices',
    'icon-flash': 'flive_icon_icon-flash',
    'icon-push-notification': 'flive_icon_icon-push-notification',
    'icon-sensit-mail': 'flive_icon_icon-sensit-mail',
    'icon-sms': 'flive_icon_icon-sms',
    'icon-notification': 'flive_icon_icon-notification',
    'icon-timeline': 'flive_icon_icon-timeline',
    'icon-chart': 'flive_icon_icon-chart',
    'icon-time': 'flive_icon_icon-time',
    'icon-configuration': 'flive_icon_icon-configuration',
    'icon-sensit-add': 'flive_icon_icon-sensit-add',
    'icon-sensit-device-3': 'flive_icon_icon-sensit-device-3',
    'icon-sensit-help': 'flive_icon_icon-sensit-help',
    'icon-sensit-vibration': 'flive_icon_icon-sensit-vibration',
    'icon-sensit-temperature': 'flive_icon_icon-sensit-temperature',
    'icon-sensit-magnet': 'flive_icon_icon-sensit-magnet',
    'icon-sensit-light': 'flive_icon_icon-sensit-light',
    'icon-sensit-humidity': 'flive_icon_icon-sensit-humidity',
    'icon-sensit-door': 'flive_icon_icon-sensit-door',
    'icon-sensit-button': 'flive_icon_icon-sensit-button',
    'icon-sensit-standby': 'flive_icon_icon-sensit-standby',
    'icon-user': 'flive_icon_icon-user',
    'icon-doc-text': 'flive_icon_icon-doc-text',
    'icon-bank': 'flive_icon_icon-bank',
    'icon-battery': 'flive_icon_icon-battery',
    'icon-usb': 'flive_icon_icon-usb',
    'icon-slack': 'flive_icon_icon-slack',
    'icon-sigfox-id': 'flive_icon_icon-sigfox-id',
    'icon-close': 'flive_icon_icon-close',
    'icon-signal-1': 'flive_icon_icon-signal-1',
    'icon-signal-2': 'flive_icon_icon-signal-2',
    'icon-signal-3': 'flive_icon_icon-signal-3',
    'icon-signal-4': 'flive_icon_icon-signal-4'
  }
};

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

// eslint-disable-line no-unused-vars

var iconChildren = {
  'signal-1': _react2.default.createElement('i', null),
  'signal-2': _react2.default.createElement('i', null),
  'signal-3': _react2.default.createElement('i', null),
  'signal-4': _react2.default.createElement('i', null)
};

var propTypes = {
  /** @ignore */
  className: _propTypes2.default.string,
  name: _propTypes2.default.string.isRequired,
  variant: _propTypes2.default.oneOf(['primary', 'circle']),
  size: _propTypes2.default.oneOf(['xs', 'sm', 'md', 'lg', 'auto'])
};

var defaultProps = {
  className: undefined,
  variant: 'primary',
  size: 'sm'
};

var Icon = function Icon(_ref) {
  var name = _ref.name,
      size = _ref.size,
      className = _ref.className,
      variant = _ref.variant,
      props = _objectWithoutProperties(_ref, ['name', 'size', 'className', 'variant']);

  switch (variant) {
    case 'circle':
      return _react2.default.createElement(
        'div',
        { className: (className ? className + ' ' : '') + 'flive_icon_circle-wrapper' },
        _react2.default.createElement(
          _Background2.default,
          _extends({}, props, {
            className: (0, _getClassName3.default)((0, _classnames2.default)('circle', 'circle-' + size), _styleModuleImportMap)
          }),
          _react2.default.createElement(
            'i',
            {
              className: (0, _getClassName3.default)((0, _classnames2.default)('icon', 'icon-' + name, 'icon-auto'), _styleModuleImportMap)
            },
            iconChildren[name]
          )
        )
      );
    case 'primary':
    default:
      return _react2.default.createElement(
        _Background2.default,
        _extends({
          component: 'i'
        }, props, {
          className: (className ? className + ' ' : '') + (0, _getClassName3.default)((0, _classnames2.default)('icon', 'icon-' + name, 'icon-' + size), _styleModuleImportMap)
        }),
        iconChildren[name]
      );
  }
};

Icon.propTypes = propTypes;
Icon.defaultProps = defaultProps;

exports.default = Icon;
module.exports = exports['default'];