'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _FileInput = require('../FileInput');

var _FileInput2 = _interopRequireDefault(_FileInput);

var _Cropper = require('../Cropper');

var _Cropper2 = _interopRequireDefault(_Cropper);

var _Modal = require('../Modal');

var _Modal2 = _interopRequireDefault(_Modal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  placeHolder: _propTypes2.default.string,
  autoUpload: _propTypes2.default.bool,
  children: _propTypes2.default.func,
  sizes: _propTypes2.default.array
};

var defaultProps = {
  placeHolder: 'You can drop your file(s) here',
  autoUpload: false,
  children: undefined,
  sizes: undefined
};

var ImageInput = function (_Component) {
  _inherits(ImageInput, _Component);

  function ImageInput() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ImageInput);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ImageInput.__proto__ || Object.getPrototypeOf(ImageInput)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      cropperImage: undefined
    }, _this.getInputProps = function (customProps) {
      return (0, _FileInput.getFileInputProps)(customProps || _this.props);
    }, _this.changeValue = function (value) {
      return (0, _FileInput.changeValue)({ value: value, props: _this.props });
    }, _this.handleDrop = function (_ref2, handleSubmitFiles) {
      var _ref3 = _toArray(_ref2),
          value = _ref3[0],
          values = _ref3.slice(1);

      var autoUpload = _this.props.autoUpload;

      _this.handleEdit(value, 0);
      _this.changeValue([value].concat(_toConsumableArray(values)).map(function (fileObject) {
        return _extends({}, fileObject, {
          originalFile: fileObject.file,
          originalType: fileObject.type,
          status: 'waiting'
        });
      }));
      if (values.length && autoUpload) setTimeout(function () {
        return handleSubmitFiles(values);
      }, 0);
    }, _this.handleEdit = function (file, row) {
      _this.setState({
        cropperImage: _extends({
          originalFile: file.originalFile || file.file,
          originalType: file.originalType || file.type
        }, file),
        cropperImageRow: row
      });
    }, _this.handlerCrop = function (handleSubmitFiles) {
      return function (cropperData) {
        var cropperImageRow = _this.state.cropperImageRow;
        var autoUpload = _this.props.autoUpload;

        var _this$getInputProps = _this.getInputProps(),
            _this$getInputProps$v = _toArray(_this$getInputProps.value),
            value = _this$getInputProps$v.slice(0);

        value[cropperImageRow] = _extends({}, cropperData, { status: 'waiting' });
        _this.changeValue(value);
        if (autoUpload) setTimeout(function () {
          return handleSubmitFiles(value);
        }, 0);
        _this.setState({
          cropperImage: undefined
        });
      };
    }, _this.handlerCancelCrop = function (handleSubmitFiles) {
      return function () {
        var cropperImageRow = _this.state.cropperImageRow;

        var _this$getInputProps2 = _this.getInputProps(),
            _this$getInputProps2$ = _toArray(_this$getInputProps2.value),
            value = _this$getInputProps2$.slice(0);

        var autoUpload = _this.props.autoUpload;

        var fileObject = value[cropperImageRow];
        if (fileObject.file) {
          value[cropperImageRow] = _extends({}, fileObject, {
            originalFile: fileObject.file,
            originalType: fileObject.type,
            status: 'waiting'
          });
        }
        _this.changeValue(value);
        if (autoUpload && fileObject.file) setTimeout(function () {
          return handleSubmitFiles(value);
        }, 0);
        _this.setState({
          cropperImage: undefined
        });
      };
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ImageInput, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          placeHolder = _props.placeHolder,
          sizes = _props.sizes,
          children = _props.children,
          rest = _objectWithoutProperties(_props, ['placeHolder', 'sizes', 'children']);

      var cropperImage = this.state.cropperImage;

      return _react2.default.createElement(
        _FileInput2.default,
        _extends({
          placeHolder: placeHolder,
          onDrop: this.handleDrop
        }, (0, _omit2.default)(rest, ['autoUpload'])),
        function (props) {
          var value = props.value,
              handleDelete = props.handleDelete,
              handleSubmitFiles = props.handleSubmitFiles;

          return value && !!value.length && _react2.default.createElement(
            _FileInput.ListFiles,
            {
              value: value,
              handleDelete: handleDelete,
              handleEdit: _this2.handleEdit,
              customModalEdit: true
            },
            cropperImage && _react2.default.createElement(
              _Modal2.default,
              { isOpen: true, size: 'lg' },
              _react2.default.createElement(
                _Modal.Body,
                null,
                _react2.default.createElement(_Cropper2.default, {
                  value: cropperImage,
                  meta: cropperImage.meta,
                  onCrop: _this2.handlerCrop(handleSubmitFiles),
                  onCancelCrop: _this2.handlerCancelCrop(handleSubmitFiles),
                  sizes: sizes
                })
              )
            ),
            children && children(props)
          );
        }
      );
    }
  }]);

  return ImageInput;
}(_react.Component);

ImageInput.propTypes = propTypes;
ImageInput.defaultProps = defaultProps;

exports.default = ImageInput;
module.exports = exports['default'];