'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _getClassName2 = require('babel-plugin-react-css-modules/dist/browser/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _styleModuleImportMap = {
  './main-content-wrapper.scss': {
    'base': 'flive_main-content-wrapper_base',
    'with-header': 'flive_main-content-wrapper_with-header flive_main-content-wrapper_base',
    'margin-left': 'flive_main-content-wrapper_margin-left flive_main-content-wrapper_base',
    'margin-left-sm': 'flive_main-content-wrapper_margin-left-sm',
    'margin-left-md': 'flive_main-content-wrapper_margin-left-md',
    'margin-left-lg': 'flive_main-content-wrapper_margin-left-lg',
    'margin-right': 'flive_main-content-wrapper_margin-right flive_main-content-wrapper_base',
    'margin-right-sm': 'flive_main-content-wrapper_margin-right-sm',
    'margin-right-md': 'flive_main-content-wrapper_margin-right-md',
    'margin-right-lg': 'flive_main-content-wrapper_margin-right-lg',
    'breakpoint-mobile': 'flive_main-content-wrapper_breakpoint-mobile',
    'nomargin-xs': 'flive_main-content-wrapper_nomargin-xs',
    'nomargin-sm': 'flive_main-content-wrapper_nomargin-sm',
    'nomargin-md': 'flive_main-content-wrapper_nomargin-md',
    'nomargin-lg': 'flive_main-content-wrapper_nomargin-lg',
    'nomargin-xl': 'flive_main-content-wrapper_nomargin-xl'
  }
};

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MainContentWrapper = function (_PureComponent) {
  _inherits(MainContentWrapper, _PureComponent);

  function MainContentWrapper() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, MainContentWrapper);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = MainContentWrapper.__proto__ || Object.getPrototypeOf(MainContentWrapper)).call.apply(_ref, [this].concat(args))), _this), _this.componentWillMount = function () {
      if (_this.context.layout) {
        _this.context.layout.register('main-content', {});
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(MainContentWrapper, [{
    key: 'render',
    value: function render() {
      var _context$layout$confi = this.context.layout.config,
          header = _context$layout$confi.header,
          sideColumn = _context$layout$confi.sideColumn;

      var _props = this.props,
          className = _props.className,
          props = _objectWithoutProperties(_props, ['className']);

      var style = [];
      if (header && header.fixed) style.push('with-header');
      if (sideColumn && !sideColumn.onlyCollapsible && sideColumn.side) {
        style.push('margin-' + sideColumn.side);
        if (sideColumn.size) {
          style.push('margin-' + sideColumn.side + '-' + sideColumn.size);
        }
        if (sideColumn.collapsible) {
          sideColumn.collapsible.forEach(function (element) {
            style.push('nomargin-' + element);
          });
        } else {
          style.push('breakpoint-mobile');
        }
      }
      if (style.length === 0) style.push('base');

      return _react2.default.createElement('main', _extends({}, props, {
        className: (className ? className + ' ' : '') + (0, _getClassName3.default)(style.join(' '), _styleModuleImportMap)
      }));
    }
  }]);

  return MainContentWrapper;
}(_react.PureComponent);

MainContentWrapper.propTypes = {
  /** @ignore */
  className: _propTypes2.default.string
};
MainContentWrapper.defaultProps = {
  className: undefined
};
MainContentWrapper.contextTypes = {
  layout: _propTypes2.default.object
};
exports.default = MainContentWrapper;
module.exports = exports['default'];