'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _getClassName2 = require('babel-plugin-react-css-modules/dist/browser/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Item = require('./Item');

var _Item2 = _interopRequireDefault(_Item);

var _Section = require('../Section');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _styleModuleImportMap = {
  './main-footer.scss': {
    'base': 'flive_main-footer_base',
    'secondary': 'flive_main-footer_secondary',
    'inner': 'flive_main-footer_inner',
    'full-width': 'flive_main-footer_full-width flive_main-footer_base'
  }
};

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = {
  /** @ignore */
  className: _propTypes2.default.string,
  /** @ignore  */
  children: _propTypes2.default.node,
  secondary: _propTypes2.default.bool,
  component: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object, _propTypes2.default.func]),
  innerComponent: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object, _propTypes2.default.func])
};

var defaultProps = {
  className: undefined,
  children: null,
  secondary: false,
  component: 'footer',
  innerComponent: 'ul'
};

var MainFooter = function MainFooter(_ref) {
  var className = _ref.className,
      children = _ref.children,
      secondary = _ref.secondary,
      Component = _ref.component,
      InnerComponent = _ref.innerComponent,
      props = _objectWithoutProperties(_ref, ['className', 'children', 'secondary', 'component', 'innerComponent']);

  return _react2.default.createElement(
    Component,
    _extends({}, props, {
      className: (className ? className + ' ' : '') + (0, _getClassName3.default)((0, _classnames2.default)({ secondary: secondary }, 'full-width'), _styleModuleImportMap)
    }),
    _react2.default.createElement(
      InnerComponent,
      { className: 'flive_main-footer_inner' },
      children
    )
  );
};

MainFooter.propTypes = propTypes;
MainFooter.defaultProps = defaultProps;

MainFooter.Item = _Item2.default;
MainFooter.Column = _Section.Column;
MainFooter.Row = _Section.Row;

exports.default = MainFooter;
module.exports = exports['default'];