'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Icon = require('../../Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = {
  /** @ignore */
  className: _propTypes2.default.string,
  /** @ignore */
  children: _propTypes2.default.node,
  title: _propTypes2.default.string,
  onClose: _propTypes2.default.func,
  logo: _propTypes2.default.string
};

var defaultProps = {
  className: undefined,
  children: null,
  title: null,
  onClose: null,
  logo: ''
};

var ModalHeader = function ModalHeader(_ref) {
  var className = _ref.className,
      _ref$onClose = _ref.onClose,
      onClose = _ref$onClose === undefined ? false : _ref$onClose,
      children = _ref.children,
      logo = _ref.logo,
      title = _ref.title,
      rest = _objectWithoutProperties(_ref, ['className', 'onClose', 'children', 'logo', 'title']);

  return _react2.default.createElement(
    'div',
    _extends({ className: (className ? className + ' ' : '') + 'flive_header_modal-header' }, rest),
    !!logo && _react2.default.createElement('img', { className: 'flive_header_modal-header--logo', alt: '', src: logo }),
    (children || title) && _react2.default.createElement(
      'h2',
      { className: 'flive_header_modal-header--title' },
      children || title
    ),
    onClose && _react2.default.createElement(
      'button',
      {
        className: 'flive_header_modal-header--close',
        title: 'close',
        onClick: onClose
      },
      _react2.default.createElement(_Icon2.default, { name: 'close' })
    )
  );
};

ModalHeader.propTypes = propTypes;
ModalHeader.defaultProps = defaultProps;

exports.default = ModalHeader;
module.exports = exports['default'];