'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Dropdown = require('../../Dropdown');

var _Dropdown2 = _interopRequireDefault(_Dropdown);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = {
  variant: _propTypes2.default.string,
  level: _propTypes2.default.oneOf([1, 2]),
  size: _propTypes2.default.string
};
var defaultProps = {
  variant: null,
  level: 1,
  size: null
};

var NavDropdown = function NavDropdown(_ref) {
  var level = _ref.level,
      initialVariant = _ref.variant,
      initialSize = _ref.size,
      props = _objectWithoutProperties(_ref, ['level', 'variant', 'size']);

  var variant = void 0;
  var size = void 0;
  if (!initialVariant) {
    variant = level === 1 ? 'dash-lagoon' : 'dash-night-blue';
  } else {
    variant = initialVariant;
  }
  if (!initialSize) {
    size = level === 1 ? 'nav-bar' : 'nav-bar-level-2';
  } else {
    size = initialSize;
  }
  return _react2.default.createElement(_Dropdown2.default, _extends({ variant: variant, size: size }, props));
};

NavDropdown.propTypes = propTypes;
NavDropdown.defaultProps = defaultProps;

NavDropdown.Trigger = _Dropdown2.default.Trigger;
NavDropdown.Content = _Dropdown2.default.Content;
NavDropdown.Item = _Dropdown2.default.Item;
NavDropdown.Separation = _Dropdown2.default.Separation;

exports.default = NavDropdown;
module.exports = exports['default'];