'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = {
  value: _propTypes2.default.string,
  total: _propTypes2.default.string,
  showPercentage: _propTypes2.default.bool,
  className: _propTypes2.default.string
};

var defaultProps = {
  value: 0,
  total: 100,
  showPercentage: true,
  className: null
};

/**
 * Progress bar
 */
var Progress = function Progress(props) {
  var className = props.className,
      value = props.value,
      total = props.total,
      showPercentage = props.showPercentage,
      rest = _objectWithoutProperties(props, ['className', 'value', 'total', 'showPercentage']);

  var percentage = Math.floor(parseInt(value, 10) / parseInt(total, 10) * 100) + '%';

  return _react2.default.createElement(
    'div',
    { className: 'flive_progress_container' },
    _react2.default.createElement(
      'div',
      _extends({
        className: (className ? className + ' ' : '') + 'flive_progress_progress'
      }, rest, {
        style: {
          width: showPercentage ? '95%' : '100%'
        }
      }),
      _react2.default.createElement('div', {
        className: 'flive_progress_bar',
        style: {
          width: percentage
        }
      })
    ),
    _react2.default.createElement(
      'span',
      { className: 'flive_progress_percentage', style: { display: showPercentage ? 'inline-block' : 'none' } },
      percentage
    )
  );
};

Progress.propTypes = propTypes;
Progress.defaultProps = defaultProps;
Progress.componentName = 'Progress';

exports.default = Progress;
module.exports = exports['default'];