'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _FieldControl = require('../FieldControl');

var _FieldControl2 = _interopRequireDefault(_FieldControl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /* eslint-disable jsx-a11y/label-has-for, jsx-a11y/no-static-element-interactions */


function getInputProps(props) {
  var input = props.input,
      resultProps = _objectWithoutProperties(props, ['input']);

  return _extends({}, resultProps, input);
}

var Radio = function (_React$Component) {
  _inherits(Radio, _React$Component);

  function Radio() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Radio);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Radio.__proto__ || Object.getPrototypeOf(Radio)).call.apply(_ref, [this].concat(args))), _this), _this.handleOnChange = function (value) {
      return function () {
        var _ref2 = _this.props.input || _this.props,
            onChange = _ref2.onChange;

        if (typeof onChange === 'function') {
          onChange(value);
        }
      };
    }, _this.handleOnBlur = function (value) {
      return function () {
        var _ref3 = _this.props.input || _this.props,
            onBlur = _ref3.onBlur;

        if (typeof onBlur === 'function') {
          onBlur(value);
        }
      };
    }, _this.handleOnClick = function (ref) {
      return function () {
        _this[ref].focus();
      };
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Radio, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          options = _props.options,
          props = _objectWithoutProperties(_props, ['options']);

      var parsedOptions = Array.isArray(options) ? options : Object.keys(options).map(function (key) {
        return { label: key, value: options[key] };
      });

      return _react2.default.createElement(
        _FieldControl2.default,
        props,
        function (restProps) {
          var _getInputProps = getInputProps(restProps),
              value = _getInputProps.value,
              disabled = _getInputProps.disabled,
              resultProps = _objectWithoutProperties(_getInputProps, ['value', 'disabled']);

          return parsedOptions.map(function (_ref4) {
            var optionValue = _ref4.value,
                optionLabel = _ref4.label,
                optionDisabled = _ref4.disabled;
            return _react2.default.createElement(
              'div',
              { className: 'flive_radio_radio', key: optionValue },
              _react2.default.createElement(
                'label',
                { onClick: _this2.handleOnClick(optionValue) },
                _react2.default.createElement('input', _extends({
                  ref: function ref(input) {
                    _this2[optionValue] = input;
                  },
                  type: 'radio',
                  value: optionValue,
                  checked: JSON.stringify(value) === JSON.stringify(optionValue),
                  onChange: _this2.handleOnChange(optionValue),
                  onBlur: _this2.handleOnBlur(optionValue),
                  disabled: disabled || optionDisabled
                }, (0, _omit2.default)(resultProps, ['onChange', 'onBlur', 'checked']))),
                optionLabel
              )
            );
          });
        }
      );
    }
  }]);

  return Radio;
}(_react2.default.Component);

Radio.propTypes = {
  disabled: _propTypes2.default.bool,
  options: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.array]),
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.bool, _propTypes2.default.array, _propTypes2.default.object]),
  onChange: _propTypes2.default.func,
  input: _propTypes2.default.object
};
Radio.defaultProps = {
  disabled: false,
  options: [],
  value: null,
  onChange: null,
  input: null
};
exports.default = Radio;
module.exports = exports['default'];