'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _StyleButton = require('./StyleButton');

var _StyleButton2 = _interopRequireDefault(_StyleButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BlockStyleControls = function (_PureComponent) {
  _inherits(BlockStyleControls, _PureComponent);

  function BlockStyleControls() {
    _classCallCheck(this, BlockStyleControls);

    return _possibleConstructorReturn(this, (BlockStyleControls.__proto__ || Object.getPrototypeOf(BlockStyleControls)).apply(this, arguments));
  }

  _createClass(BlockStyleControls, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          editorState = _props.editorState,
          _props$controls = _props.controls,
          controls = _props$controls === undefined ? [] : _props$controls;

      var selection = editorState.getSelection();
      var blockType = editorState.getCurrentContent().getBlockForKey(selection.getStartKey()).getType();
      return _react2.default.createElement(
        'div',
        { className: 'rich-text-editor--controls-section' },
        controls.map(function (type) {
          return _react2.default.createElement(_StyleButton2.default, {
            key: 'Block' + type.label + '-' + type.className,
            active: type.style === blockType,
            label: type.label,
            onToggle: _this2.props.onToggle,
            style: type.style,
            className: type.className
          });
        })
      );
    }
  }]);

  return BlockStyleControls;
}(_react.PureComponent);

BlockStyleControls.propTypes = {
  editorState: _propTypes2.default.object,
  onToggle: _propTypes2.default.func,
  controls: _propTypes2.default.array
};

BlockStyleControls.defaultProps = {
  editorState: null,
  onToggle: null,
  controls: null
};

exports.default = BlockStyleControls;
module.exports = exports['default'];