'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _getClassName2 = require('babel-plugin-react-css-modules/dist/browser/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _styleModuleImportMap = {
  './app-title.scss': {
    'base': 'flive_app-title_base',
    'dark': 'flive_app-title_dark',
    'sm': 'flive_app-title_sm',
    'md': 'flive_app-title_md',
    'lg': 'flive_app-title_lg',
    'hidden-xs': 'flive_app-title_hidden-xs',
    'hidden-sm': 'flive_app-title_hidden-sm',
    'hidden-md': 'flive_app-title_hidden-md',
    'hidden-lg': 'flive_app-title_hidden-lg',
    'hidden-xl': 'flive_app-title_hidden-xl'
  }
};

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = {
  /** @ignore */
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,
  /** sizes where button is expected to be hidden (ex: "lg xl") */
  hidden: _propTypes2.default.string,
  size: _propTypes2.default.oneOf(['sm', 'md', 'lg']),
  variant: _propTypes2.default.oneOf(['', 'dark']),
  /** destination of link */
  linkTo: _propTypes2.default.string
};

var defaultProps = {
  className: undefined,
  children: [],
  hidden: null,
  size: 'md',
  variant: '',
  linkTo: '/'
};

/**
 * An Item to fit inside the SideMenu (or SubMenu)
 */
var AppTitle = function AppTitle(props) {
  var className = props.className,
      children = props.children,
      hidden = props.hidden,
      size = props.size,
      variant = props.variant,
      linkTo = props.linkTo,
      rest = _objectWithoutProperties(props, ['className', 'children', 'hidden', 'size', 'variant', 'linkTo']);

  var hiddenSizes = hidden ? hidden.split(' ').map(function (screensize) {
    return 'hidden-' + screensize;
  }) : hidden;

  return _react2.default.createElement(
    'a',
    _extends({ href: linkTo }, rest, {
      className: (className ? className + ' ' : '') + (0, _getClassName3.default)((0, _classnames2.default)('base', size, variant, hiddenSizes), _styleModuleImportMap)
    }),
    children
  );
};

AppTitle.propTypes = propTypes;
AppTitle.defaultProps = defaultProps;
AppTitle.componentName = 'AppTitle';

exports.default = AppTitle;
module.exports = exports['default'];