'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _getClassName2 = require('babel-plugin-react-css-modules/dist/browser/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _styleModuleImportMap = {
  './burger-button.scss': {
    'base': 'flive_burger-button_base',
    'right': 'flive_burger-button_right',
    'hidden-xs': 'flive_burger-button_hidden-xs',
    'hidden-sm': 'flive_burger-button_hidden-sm',
    'hidden-md': 'flive_burger-button_hidden-md',
    'hidden-lg': 'flive_burger-button_hidden-lg',
    'hidden-xl': 'flive_burger-button_hidden-xl',
    'middle': 'flive_burger-button_middle',
    'light': 'flive_burger-button_light',
    'dark': 'flive_burger-button_dark',
    'state-open': 'flive_burger-button_state-open',
    'left': 'flive_burger-button_left'
  }
};

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var propTypes = {
  /** @ignore */
  className: _propTypes2.default.string,
  /** @ignore */
  onClick: _propTypes2.default.func,
  /** @ignore */
  disabled: _propTypes2.default.bool,
  /** menu is open */
  open: _propTypes2.default.bool,
  /** sizes where button is expected to be hidden (ex: "lg xl") */
  hidden: _propTypes2.default.string,
  variant: _propTypes2.default.oneOf(['light', 'dark']),
  side: _propTypes2.default.oneOf(['left', 'right'])
};

var defaultProps = {
  className: undefined,
  onClick: null,
  disabled: false,
  open: false,
  hidden: null,
  variant: 'light',
  side: 'left'
};

/**
 * An Item to fit inside the SideMenu (or SubMenu)
 */
var BurgerButton = function BurgerButton(props) {
  var className = props.className,
      onClick = props.onClick,
      disabled = props.disabled,
      open = props.open,
      hidden = props.hidden,
      variant = props.variant,
      side = props.side,
      rest = _objectWithoutProperties(props, ['className', 'onClick', 'disabled', 'open', 'hidden', 'variant', 'side']);

  var hiddenSizes = hidden ? hidden.split(' ').map(function (screensize) {
    return 'hidden-' + screensize;
  }) : hidden;

  var onDisabledLink = function onDisabledLink(e) {
    if (disabled) {
      e.preventDefault();
    } else if (onClick) {
      onClick(e);
    }
  };

  return _react2.default.createElement(
    'button',
    _extends({
      onClick: onDisabledLink,
      disabled: disabled
    }, rest, {
      className: (className ? className + ' ' : '') + (0, _getClassName3.default)((0, _classnames2.default)('base', variant, side, hiddenSizes, {
        'state-open': open
      }), _styleModuleImportMap)
    }),
    _react2.default.createElement('span', {
      className: (0, _getClassName3.default)((0, _classnames2.default)('middle'), _styleModuleImportMap)
    })
  );
};

BurgerButton.propTypes = propTypes;
BurgerButton.defaultProps = defaultProps;
BurgerButton.componentName = 'BurgerButton';

exports.default = BurgerButton;
module.exports = exports['default'];