'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _getClassName2 = require('babel-plugin-react-css-modules/dist/browser/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _styleModuleImportMap = {
  'item': {
    'base': 'flive_side-menu-item_base',
    'separation-bottom': 'flive_side-menu-item_separation-bottom',
    'separation-top': 'flive_side-menu-item_separation-top',
    'separation-both': 'flive_side-menu-item_separation-both',
    'position-bottom': 'flive_side-menu-item_position-bottom',
    'trigger': 'flive_side-menu-item_trigger',
    'active': 'flive_side-menu-item_active'
  },
  'subMenu': {
    'base': 'flive_sub-menu_base',
    'separation-bottom': 'flive_sub-menu_separation-bottom',
    'separation-top': 'flive_sub-menu_separation-top',
    'separation-both': 'flive_sub-menu_separation-both',
    'position-bottom': 'flive_sub-menu_position-bottom',
    'list': 'flive_sub-menu_list',
    'item': 'flive_sub-menu_item'
  },
  'sideMenu': {
    'only-collapsible': 'flive_side-menu_only-collapsible',
    'item-only-collapsible': 'flive_side-menu_item-only-collapsible',
    'submenu-only-collapsible': 'flive_side-menu_submenu-only-collapsible',
    'base': 'flive_side-menu_base',
    'sm': 'flive_side-menu_sm',
    'md': 'flive_side-menu_md',
    'lg': 'flive_side-menu_lg',
    'with-header': 'flive_side-menu_with-header',
    'list': 'flive_side-menu_list',
    'light': 'flive_side-menu_light',
    'dark': 'flive_side-menu_dark',
    'overlay': 'flive_side-menu_overlay',
    'left': 'flive_side-menu_left',
    'right': 'flive_side-menu_right',
    'state-open': 'flive_side-menu_state-open',
    'collapsible-xs': 'flive_side-menu_collapsible-xs',
    'collapsible-sm': 'flive_side-menu_collapsible-sm',
    'collapsible-md': 'flive_side-menu_collapsible-md',
    'collapsible-lg': 'flive_side-menu_collapsible-lg',
    'collapsible-xl': 'flive_side-menu_collapsible-xl'
  }
};

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// eslint-disable-line no-unused-vars

// eslint-disable-line no-unused-vars
// eslint-disable-line no-unused-vars
var propTypes = {
  /** @ignore */
  children: _propTypes2.default.node,
  /** @ignore */
  className: _propTypes2.default.string,
  /** @ignore */
  closeMenu: _propTypes2.default.func,
  /** A component: button, a, react router Link, etc... */
  componentWrapper: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object, _propTypes2.default.func]),
  /** A component: button, a, react router Link, etc... */
  component: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object, _propTypes2.default.func]),
  /** A function called on click */
  onClick: _propTypes2.default.func,
  /** Disabled bool */
  disabled: _propTypes2.default.bool,
  /** A boolean that prevents the menu from closing after a click on the item */
  preventsMenuClose: _propTypes2.default.bool,
  /** A separation above and/or below the item */
  separation: _propTypes2.default.oneOf(['top', 'bottom', 'both']),
  active: _propTypes2.default.bool,
  bottom: _propTypes2.default.bool,
  /** true => submenu is hidden when menu not collapsible */
  onlyCollapsible: _propTypes2.default.bool
};

var defaultProps = {
  children: undefined,
  className: undefined,
  onClick: null,
  closeMenu: undefined,
  disabled: false,
  componentWrapper: 'li',
  component: 'span',
  preventsMenuClose: false,
  separation: null,
  active: false,
  bottom: false,
  onlyCollapsible: false
};

/**
 * An Item to fit inside the SideMenu (or SubMenu)
 */

var Item = function (_PureComponent) {
  _inherits(Item, _PureComponent);

  function Item() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Item);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Item.__proto__ || Object.getPrototypeOf(Item)).call.apply(_ref, [this].concat(args))), _this), _this.onClick = function (e) {
      var _this$props = _this.props,
          onClick = _this$props.onClick,
          closeMenu = _this$props.closeMenu,
          preventsMenuClose = _this$props.preventsMenuClose,
          disabled = _this$props.disabled;


      if (disabled) {
        e.preventDefault();
      } else if (onClick) {
        onClick(e);
      }

      if (!preventsMenuClose && !disabled && closeMenu) {
        closeMenu();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Item, [{
    key: 'render',
    value: function render() {
      var _classNames;

      var _props = this.props,
          children = _props.children,
          className = _props.className,
          disabled = _props.disabled,
          ComponentWrapper = _props.componentWrapper,
          Component = _props.component,
          separation = _props.separation,
          active = _props.active,
          bottom = _props.bottom,
          onlyCollapsible = _props.onlyCollapsible,
          closeMenu = _props.closeMenu,
          preventsMenuClose = _props.preventsMenuClose,
          rest = _objectWithoutProperties(_props, ['children', 'className', 'disabled', 'componentWrapper', 'component', 'separation', 'active', 'bottom', 'onlyCollapsible', 'closeMenu', 'preventsMenuClose']);

      return _react2.default.createElement(
        ComponentWrapper,
        {
          className: (className ? className + ' ' : '') + (0, _getClassName3.default)((0, _classnames2.default)('item.base', (_classNames = {
            'item.position-bottom': bottom,
            'item.active': active
          }, _defineProperty(_classNames, 'item.separation-' + separation, separation), _defineProperty(_classNames, 'sideMenu.item-only-collapsible', onlyCollapsible), _classNames)), _styleModuleImportMap)
        },
        _react2.default.createElement(
          Component,
          _extends({ className: 'flive_side-menu-item_trigger flive_sub-menu_item' }, rest, { onClick: this.onClick }, { disabled: disabled }),
          children
        )
      );
    }
  }]);

  return Item;
}(_react.PureComponent);

Item.propTypes = propTypes;
Item.defaultProps = defaultProps;
Item.componentName = 'Item';

exports.default = Item;
module.exports = exports['default'];