'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _getClassName2 = require('babel-plugin-react-css-modules/dist/browser/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _index = require('../Item/index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _styleModuleImportMap = {
  'subMenu': {
    'base': 'flive_sub-menu_base',
    'separation-bottom': 'flive_sub-menu_separation-bottom',
    'separation-top': 'flive_sub-menu_separation-top',
    'separation-both': 'flive_sub-menu_separation-both',
    'position-bottom': 'flive_sub-menu_position-bottom',
    'list': 'flive_sub-menu_list',
    'item': 'flive_sub-menu_item'
  },
  'sideMenu': {
    'only-collapsible': 'flive_side-menu_only-collapsible',
    'item-only-collapsible': 'flive_side-menu_item-only-collapsible',
    'submenu-only-collapsible': 'flive_side-menu_submenu-only-collapsible',
    'base': 'flive_side-menu_base',
    'sm': 'flive_side-menu_sm',
    'md': 'flive_side-menu_md',
    'lg': 'flive_side-menu_lg',
    'with-header': 'flive_side-menu_with-header',
    'list': 'flive_side-menu_list',
    'light': 'flive_side-menu_light',
    'dark': 'flive_side-menu_dark',
    'overlay': 'flive_side-menu_overlay',
    'left': 'flive_side-menu_left',
    'right': 'flive_side-menu_right',
    'state-open': 'flive_side-menu_state-open',
    'collapsible-xs': 'flive_side-menu_collapsible-xs',
    'collapsible-sm': 'flive_side-menu_collapsible-sm',
    'collapsible-md': 'flive_side-menu_collapsible-md',
    'collapsible-lg': 'flive_side-menu_collapsible-lg',
    'collapsible-xl': 'flive_side-menu_collapsible-xl'
  }
};

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

// eslint-disable-line no-unused-vars

// eslint-disable-line no-unused-vars
var propTypes = {
  /** @ignore */
  children: _propTypes2.default.node,
  /** @ignore */
  className: _propTypes2.default.string,
  /** @ignore */
  closeMenu: _propTypes2.default.func,
  /** An Item */
  title: _propTypes2.default.node.isRequired,
  separation: _propTypes2.default.oneOf(['top', 'bottom', 'both']),
  bottom: _propTypes2.default.bool,
  /** A component: ul, div etc... */
  component: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object, _propTypes2.default.func]),
  /** true => item is hidden when menu not collapsible */
  onlyCollapsible: _propTypes2.default.bool
};

var defaultProps = {
  children: undefined,
  className: undefined,
  closeMenu: undefined,
  separation: null,
  bottom: false,
  component: 'ul',
  onlyCollapsible: false
};

/**
 * a Sub Menu that fits inside the SideMenu
 */
var SubMenu = function SubMenu(props) {
  var _classNames;

  var children = props.children,
      className = props.className,
      title = props.title,
      separation = props.separation,
      bottom = props.bottom,
      Component = props.component,
      onlyCollapsible = props.onlyCollapsible,
      closeMenu = props.closeMenu,
      rest = _objectWithoutProperties(props, ['children', 'className', 'title', 'separation', 'bottom', 'component', 'onlyCollapsible', 'closeMenu']);

  return _react2.default.createElement(
    'div',
    _extends({}, rest, {
      className: (className ? className + ' ' : '') + (0, _getClassName3.default)((0, _classnames2.default)('subMenu.base', (_classNames = {
        'subMenu.position-bottom': bottom
      }, _defineProperty(_classNames, 'subMenu.separation-' + separation, separation), _defineProperty(_classNames, 'sideMenu.submenu-only-collapsible', onlyCollapsible), _classNames)), _styleModuleImportMap)
    }),
    _react2.default.Children.map(title, function (child) {
      var isValidElement = _react2.default.isValidElement(child);
      if (isValidElement) {
        return _react2.default.cloneElement(child, { closeMenu: closeMenu });
      }
      return child;
    }),
    _react2.default.createElement(
      Component,
      { className: 'flive_sub-menu_list' },
      _react2.default.Children.map(children, function (child) {
        var isValidElement = _react2.default.isValidElement(child);
        if (isValidElement && (child.type === _index2.default || child.type === SubMenu)) {
          return _react2.default.cloneElement(child, { closeMenu: closeMenu });
        }
        return child;
      })
    )
  );
};

SubMenu.propTypes = propTypes;
SubMenu.defaultProps = defaultProps;
SubMenu.componentName = 'SubMenu';

exports.default = SubMenu;
module.exports = exports['default'];