'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _getClassName2 = require('babel-plugin-react-css-modules/dist/browser/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _index = require('./Item/index');

var _index2 = _interopRequireDefault(_index);

var _index3 = require('./SubMenu/index');

var _index4 = _interopRequireDefault(_index3);

var _index5 = require('./BurgerButton/index');

var _index6 = _interopRequireDefault(_index5);

var _index7 = require('./AppTitle/index');

var _index8 = _interopRequireDefault(_index7);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _styleModuleImportMap = {
  './side-menu.scss': {
    'only-collapsible': 'flive_side-menu_only-collapsible',
    'item-only-collapsible': 'flive_side-menu_item-only-collapsible',
    'submenu-only-collapsible': 'flive_side-menu_submenu-only-collapsible',
    'base': 'flive_side-menu_base',
    'sm': 'flive_side-menu_sm',
    'md': 'flive_side-menu_md',
    'lg': 'flive_side-menu_lg',
    'with-header': 'flive_side-menu_with-header',
    'list': 'flive_side-menu_list',
    'light': 'flive_side-menu_light',
    'dark': 'flive_side-menu_dark',
    'overlay': 'flive_side-menu_overlay',
    'left': 'flive_side-menu_left',
    'right': 'flive_side-menu_right',
    'state-open': 'flive_side-menu_state-open',
    'collapsible-xs': 'flive_side-menu_collapsible-xs',
    'collapsible-sm': 'flive_side-menu_collapsible-sm',
    'collapsible-md': 'flive_side-menu_collapsible-md',
    'collapsible-lg': 'flive_side-menu_collapsible-lg',
    'collapsible-xl': 'flive_side-menu_collapsible-xl'
  }
};

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  /** children is a function, has closeMenu func as prop */
  children: _propTypes2.default.func.isRequired,
  /** @ignore */
  className: _propTypes2.default.string,
  /** @ignore */
  side: _propTypes2.default.oneOf(['left', 'right']),
  size: _propTypes2.default.oneOf(['sm', 'md', 'lg']),
  variant: _propTypes2.default.oneOf(['light', 'dark']),
  /** A component: ul, div etc... */
  component: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object, _propTypes2.default.func]),
  /** sizes where collapsible behavior is expected (ex: "xs sm") */
  collapsible: _propTypes2.default.string,
  /** true => menu is hidden when not collapsible */
  onlyCollapsible: _propTypes2.default.bool,
  hasBurgerButton: _propTypes2.default.bool,
  /** if burgerButton variant different from menu variant */
  burgerButtonVariant: _propTypes2.default.oneOf(['light', 'dark']),
  burgerButtonStyle: _propTypes2.default.object,
  /** controller for the open state of the Side Menu */
  open: _propTypes2.default.bool
};

var defaultProps = {
  className: undefined,
  size: 'md',
  variant: 'light',
  open: false,
  side: 'left',
  collapsible: null,
  hasBurgerButton: true,
  component: 'ul',
  onlyCollapsible: false,
  burgerButtonVariant: undefined,
  burgerButtonStyle: undefined
};

var contextTypes = {
  layout: _propTypes2.default.object
};

var SideMenu = function (_PureComponent) {
  _inherits(SideMenu, _PureComponent);

  function SideMenu() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, SideMenu);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SideMenu.__proto__ || Object.getPrototypeOf(SideMenu)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      open: false,
      buttonHidden: ['xs', 'sm', 'md', 'lg', 'xl'],
      collapsibleSizes: []
    }, _this.componentWillMount = function () {
      var _this$props = _this.props,
          side = _this$props.side,
          collapsible = _this$props.collapsible,
          onlyCollapsible = _this$props.onlyCollapsible,
          size = _this$props.size;

      var buttonHidden = _this.state.buttonHidden;
      var collapsibleSizes = collapsible ? collapsible.split(' ').map(function (screensize) {
        buttonHidden.splice(buttonHidden.indexOf(screensize), 1);
        return 'collapsible-' + screensize;
      }) : collapsible;
      _this.setState(_extends({}, _this.state, { buttonHidden: buttonHidden, collapsibleSizes: collapsibleSizes }));
      if (_this.context.layout) {
        _this.context.layout.register('sideColumn', { side: side, size: size, collapsible: collapsible.split(' '), onlyCollapsible: onlyCollapsible });
      }
    }, _this.toggleMenu = function (e) {
      var newState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : !_this.state.open;

      _this.setState(_extends({}, _this.state, { open: newState }));
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SideMenu, [{
    key: 'render',


    /**
     * A responsive Side Menu, with SubMenus & Items
     * (plus the BurgerButton for the responsive Navbar and the AppTitle for the "desktop" Navbar)
     */
    value: function render() {
      var _props = this.props,
          children = _props.children,
          className = _props.className,
          size = _props.size,
          variant = _props.variant,
          side = _props.side,
          onlyCollapsible = _props.onlyCollapsible,
          hasBurgerButton = _props.hasBurgerButton,
          burgerButtonVariant = _props.burgerButtonVariant,
          burgerButtonStyle = _props.burgerButtonStyle,
          Component = _props.component,
          rest = _objectWithoutProperties(_props, ['children', 'className', 'size', 'variant', 'side', 'onlyCollapsible', 'hasBurgerButton', 'burgerButtonVariant', 'burgerButtonStyle', 'component']);

      var _state = this.state,
          buttonHidden = _state.buttonHidden,
          collapsibleSizes = _state.collapsibleSizes;
      var layout = this.context.layout;

      return _react2.default.createElement(
        'div',
        {
          className: (className ? className + ' ' : '') + (0, _getClassName3.default)((0, _classnames2.default)(side, collapsibleSizes, variant, {
            'state-open': hasBurgerButton ? this.state.open : this.props.open,
            'only-collapsible': onlyCollapsible
          }), _styleModuleImportMap)
        },
        _react2.default.createElement('div', {
          onClick: this.toggleMenu,
          className: (0, _getClassName3.default)((0, _classnames2.default)('overlay', variant), _styleModuleImportMap)
        }),
        hasBurgerButton && _react2.default.createElement(_index6.default, _extends({ side: side }, {
          variant: burgerButtonVariant || variant,
          hidden: buttonHidden.join(' '),
          open: this.state.open,
          onClick: this.toggleMenu,
          style: burgerButtonStyle
        })),
        _react2.default.createElement(
          'div',
          _extends({}, rest, {
            className: (0, _getClassName3.default)((0, _classnames2.default)('base', size, side, {
              'with-header': layout && layout.config && layout.config.header && layout.config.header.fixed
            }), _styleModuleImportMap)
          }),
          _react2.default.createElement(
            Component,
            {
              className: (0, _getClassName3.default)((0, _classnames2.default)('list'), _styleModuleImportMap)
            },
            children({ closeMenu: this.toggleMenu })
          )
        )
      );
    }
  }]);

  return SideMenu;
}(_react.PureComponent);

SideMenu.propTypes = propTypes;
SideMenu.defaultProps = defaultProps;
SideMenu.contextTypes = contextTypes;

SideMenu.Item = _index2.default;
SideMenu.SubMenu = _index4.default;
SideMenu.BurgerButton = _index6.default;
SideMenu.AppTitle = _index8.default;

exports.default = SideMenu;
module.exports = exports['default'];