'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _getClassName2 = require('babel-plugin-react-css-modules/dist/browser/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _styleModuleImportMap = {
  './column.scss': {
    'base': 'flive_column_base',
    'fixed-left': 'flive_column_fixed-left flive_column_base',
    'fixed-right': 'flive_column_fixed-right flive_column_base',
    'backdrop': 'flive_column_backdrop',
    'backdrop-open': 'flive_column_backdrop-open',
    'toggle': 'flive_column_toggle',
    'toggle-active': 'flive_column_toggle-active',
    'toggle-inner': 'flive_column_toggle-inner',
    'open': 'flive_column_open'
  }
};

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable jsx-a11y/no-static-element-interactions */
/* eslint-disable jsx-a11y/href-no-hash */


var Sidebar = function (_PureComponent) {
  _inherits(Sidebar, _PureComponent);

  function Sidebar() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Sidebar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Sidebar.__proto__ || Object.getPrototypeOf(Sidebar)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      collapsed: true
    }, _this.componentWillMount = function () {
      var _this$props = _this.props,
          fixed = _this$props.fixed,
          left = _this$props.left,
          right = _this$props.right;

      if (left && right) {
        throw new Error("A Column can't be both left and right");
      }
      if (_this.context.layout) {
        _this.context.layout.register('sideColumn', { fixed: fixed, side: left ? 'left' : 'right' });
      }
    }, _this.toggleColumn = function (e) {
      e.preventDefault();
      _this.setState({ collapsed: !_this.state.collapsed });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Sidebar, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          backdropClassName = _props.backdropClassName,
          fixed = _props.fixed,
          left = _props.left,
          right = _props.right,
          name = _props.name,
          props = _objectWithoutProperties(_props, ['className', 'backdropClassName', 'fixed', 'left', 'right', 'name']);

      var columnStyle = [];
      var backdropStyle = ['backdrop'];
      var toggleStyle = ['toggle'];
      var baseStyle = fixed ? 'fixed-' : 'fluid-';
      baseStyle += left ? 'left' : 'right';
      columnStyle.push(baseStyle);

      if (fixed && !this.state.collapsed) {
        toggleStyle.push('toggle-active');
        backdropStyle.push('backdrop-open');
        columnStyle.push('open');
      }

      return _react2.default.createElement(
        'div',
        { onClick: this.toggleColumn, className: (backdropClassName ? backdropClassName + ' ' : '') + (0, _getClassName3.default)(backdropStyle.join(' '), _styleModuleImportMap)
        },
        fixed && _react2.default.createElement(
          'a',
          { href: '#', onClick: this.toggleColumn, className: (0, _getClassName3.default)(toggleStyle.join(' '), _styleModuleImportMap)
          },
          _react2.default.createElement(
            'span',
            { className: 'flive_column_toggle-inner' },
            name
          )
        ),
        _react2.default.createElement('aside', _extends({}, props, { onClick: function onClick(e) {
            return e.stopPropagation();
          }, className: (className ? className + ' ' : '') + (0, _getClassName3.default)(columnStyle.join(' '), _styleModuleImportMap)
        }))
      );
    }
  }]);

  return Sidebar;
}(_react.PureComponent);

Sidebar.propTypes = {
  /** @ignore */
  className: _propTypes2.default.string,
  fixed: _propTypes2.default.bool,
  left: _propTypes2.default.bool,
  right: _propTypes2.default.bool,
  name: _propTypes2.default.string,
  backdropClassName: _propTypes2.default.string
};
Sidebar.defaultProps = {
  className: undefined,
  fixed: false,
  left: false,
  right: false,
  name: 'Menu',
  backdropClassName: undefined
};
Sidebar.contextTypes = {
  layout: _propTypes2.default.object
};
exports.default = Sidebar;
module.exports = exports['default'];