'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Button = require('../../Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SlideNext = function SlideNext(_ref) {
  var size = _ref.size,
      variant = _ref.variant,
      currentSlide = _ref.currentSlide,
      slideCount = _ref.slideCount,
      goToSlide = _ref.goToSlide;

  var onSlide = function onSlide(e) {
    e.preventDefault();
    goToSlide(currentSlide + 1);
  };
  return _react2.default.createElement(
    _Button2.default,
    _extends({ onClick: onSlide, disabled: currentSlide + 1 === slideCount }, { size: size, variant: variant }),
    'Next'
  );
};

SlideNext.propTypes = {
  size: _propTypes2.default.string,
  variant: _propTypes2.default.string,
  currentSlide: _propTypes2.default.number,
  slideCount: _propTypes2.default.number,
  goToSlide: _propTypes2.default.func
};

SlideNext.defaultProps = {
  size: 'lg',
  variant: 'dash-lagoon',
  currentSlide: 0,
  slideCount: 0,
  goToSlide: null
};

exports.default = SlideNext;
module.exports = exports['default'];