'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getClassName2 = require('babel-plugin-react-css-modules/dist/browser/getClassName');

var _getClassName3 = _interopRequireDefault(_getClassName2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _styleModuleImportMap = {
  './stepper-content.scss': {
    'stepper-content--primary': 'flive_stepper-content_stepper-content--primary',
    'stepper-content--band': 'flive_stepper-content_stepper-content--band',
    'size-sm': 'flive_stepper-content_size-sm',
    'size-md': 'flive_stepper-content_size-md',
    'size-lg': 'flive_stepper-content_size-lg',
    'with-border': 'flive_stepper-content_with-border'
  }
};


var componentName = 'StepperContent';

var propTypes = {
  children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]),
  variant: _propTypes2.default.string,
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),
  size: _propTypes2.default.oneOf(['sm', 'md', 'lg']),
  withBorder: _propTypes2.default.bool,
  className: _propTypes2.default.string
};

var defaultProps = {
  children: null,
  variant: 'primary',
  value: null,
  size: 'md',
  withBorder: false,
  className: undefined
};

var StepperContent = function StepperContent(_ref) {
  var children = _ref.children,
      variant = _ref.variant,
      value = _ref.value,
      size = _ref.size,
      withBorder = _ref.withBorder,
      className = _ref.className;
  return _react2.default.createElement(
    'div',
    {
      className: (className ? className + ' ' : '') + (0, _getClassName3.default)((0, _classnames2.default)('stepper-content--' + variant, 'size-' + size, { 'with-border': withBorder }), _styleModuleImportMap)
    },
    typeof children === 'function' ? children(value) : children
  );
};

StepperContent.componentName = componentName;
StepperContent.propTypes = propTypes;
StepperContent.defaultProps = defaultProps;

exports.default = StepperContent;
module.exports = exports['default'];