'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TableRow = require('./TableRow');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TableHeader = function (_PureComponent) {
  _inherits(TableHeader, _PureComponent);

  function TableHeader() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TableHeader);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TableHeader.__proto__ || Object.getPrototypeOf(TableHeader)).call.apply(_ref, [this].concat(args))), _this), _this.onCellClick = function (event, _ref2) {
      var sort = _ref2.sort,
          order = _ref2.order;
      var onChangeOrder = _this.props.onChangeOrder;

      if (onChangeOrder && sort) {
        onChangeOrder({ sort: sort, order: order });
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TableHeader, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          adjustForCheckbox = _props.adjustForCheckbox,
          sortedField = _props.sortedField,
          order = _props.order,
          className = _props.className,
          style = _props.style;


      return _react2.default.createElement(
        'thead',
        { className: className, style: style },
        (0, _TableRow.createRows)({
          children: children,
          props: {
            adjustForCheckbox: adjustForCheckbox,
            onCellClick: this.onCellClick,
            sortedField: sortedField,
            order: order
          }
        })
      );
    }
  }]);

  return TableHeader;
}(_react.PureComponent);

TableHeader.componentName = 'TableHeader';
TableHeader.propTypes = {
  /**
   * Children passed to table footer.
   */
  children: _propTypes2.default.node,
  /**
   * Controls the display of the row to adjust checkbox.
   */
  adjustForCheckbox: _propTypes2.default.bool,
  onChangeOrder: _propTypes2.default.func,
  sortedField: _propTypes2.default.array,
  order: _propTypes2.default.string,
  className: _propTypes2.default.string,
  style: _propTypes2.default.object
};
TableHeader.defaultProps = {
  children: null,
  adjustForCheckbox: false,
  onChangeOrder: null,
  sortedField: null,
  order: 'asc',
  className: '',
  style: {}
};
exports.default = TableHeader;
module.exports = exports['default'];