'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _jump = require('jump.js');

var _jump2 = _interopRequireDefault(_jump);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _Button = require('../../Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  index: _propTypes2.default.number,
  onChange: _propTypes2.default.func,
  onClick: _propTypes2.default.func,
  component: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object, _propTypes2.default.func]),
  tabDirection: _propTypes2.default.string,
  duration: _propTypes2.default.number,
  offset: _propTypes2.default.number,
  to: _propTypes2.default.string,
  variant: _propTypes2.default.string,
  withHashTag: _propTypes2.default.bool,
  scrollSpy: _propTypes2.default.object
};

var defaultProps = {
  index: 0,
  onChange: null,
  onClick: null,
  component: 'button',
  scrollSpy: null,
  tabDirection: 'column',
  duration: 0,
  offset: 0,
  to: '',
  variant: 'dash-night-blue',
  withHashTag: false,
  children: null
};

var Tab = function (_PureComponent) {
  _inherits(Tab, _PureComponent);

  function Tab() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Tab);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Tab.__proto__ || Object.getPrototypeOf(Tab)).call.apply(_ref, [this].concat(args))), _this), _this.componentDidMount = function () {
      var _this$props = _this.props,
          scrollSpy = _this$props.scrollSpy,
          offset = _this$props.offset,
          to = _this$props.to;

      if (scrollSpy && '#' + to === window.location.hash) {
        (0, _jump2.default)('#' + to, { duration: 0, offset: offset });
      }
    }, _this.handleClick = function (e) {
      var _this$props2 = _this.props,
          index = _this$props2.index,
          onChange = _this$props2.onChange,
          onClick = _this$props2.onClick,
          scrollSpy = _this$props2.scrollSpy,
          duration = _this$props2.duration,
          to = _this$props2.to,
          offset = _this$props2.offset,
          withHashTag = _this$props2.withHashTag;

      if (typeof onChange === 'function') onChange(index);
      if (typeof onClick === 'function') onClick(e);
      if (scrollSpy) {
        if (withHashTag) {
          var _window = window,
              scrollX = _window.scrollX,
              scrollY = _window.scrollY;

          window.location.hash = to;
          window.scroll(scrollX, scrollY);
          setTimeout(function () {
            (0, _jump2.default)('#' + to, { duration: duration, offset: offset });
          }, 50);
        } else {
          (0, _jump2.default)('#' + to, { duration: duration, offset: offset });
        }
      }
      e.preventDefault();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Tab, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          tabDirection = _props.tabDirection,
          component = _props.component,
          to = _props.to,
          onClick = _props.onClick,
          scrollSpy = _props.scrollSpy,
          onChange = _props.onChange,
          variant = _props.variant,
          rest = _objectWithoutProperties(_props, ['tabDirection', 'component', 'to', 'onClick', 'scrollSpy', 'onChange', 'variant']);

      return _react2.default.createElement(_Button2.default, _extends({
        variant: tabDirection === 'column' ? 'tab' : variant,
        size: tabDirection === 'column' ? 'md' : 'nav-bar-level-2',
        component: component,
        onClick: this.handleClick
      }, (0, _omit2.default)(rest, Object.keys(propTypes))));
    }
  }]);

  return Tab;
}(_react.PureComponent);

Tab.componentName = 'Tab';

Tab.propTypes = propTypes;
Tab.defaultProps = defaultProps;

exports.default = Tab;
module.exports = exports['default'];