'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactTestRenderer = require('react-test-renderer');

var _reactTestRenderer2 = _interopRequireDefault(_reactTestRenderer);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Tab = _index2.default.Tab,
    TabsContainer = _index2.default.TabsContainer,
    Content = _index2.default.Content; // eslint-disable-line import/no-extraneous-dependencies

test('Tabs renders correctly', function () {
  var tree = _reactTestRenderer2.default.create(_react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(
      _index2.default,
      null,
      _react2.default.createElement(
        TabsContainer,
        {
          sticky: {
            topOffset: -110
          },
          scrollSpy: {
            topOffset: -50
          },
          style: { position: 'fixed', top: 0, right: 0 }
        },
        _react2.default.createElement(
          Tab,
          { selected: true, to: 'tab1' },
          'Tab 1'
        ),
        _react2.default.createElement(
          Tab,
          { to: 'tab2' },
          'Tab 2'
        ),
        _react2.default.createElement(
          Tab,
          { to: 'tab3' },
          'Tab 3'
        )
      ),
      _react2.default.createElement(
        Content,
        null,
        _react2.default.createElement(
          'div',
          { id: 'tab1' },
          'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Phasellus consequat, massa posuere eleifend tincidunt, erat velit malesuada orci, sit amet vehicula tortor eros vel ipsum. Integer bibendum nunc eu eros blandit gravida. Aliquam erat volutpat. Phasellus non orci tristique, porttitor elit non, luctus augue. Vestibulum a aliquam quam. Proin eget orci ante. Phasellus viverra, erat sed sagittis ornare,'
        ),
        _react2.default.createElement(
          'div',
          { id: 'tab2' },
          'Nullam vel neque laoreet, interdum est eu, semper dui. Aliquam pretium urna vel mauris porttitor, in cursus dolor condimentum. Aliquam vitae faucibus nunc. Phasellus eleifend, ipsum quis auctor luctus, est nibh euismod odio, eu luctus lacus orci ac tellus. Donec pretium elit sapien, sit amet lobortis risus finibus bibendum. Ut feugiat mollis quam a fringilla. Curabitur vitae neque quis diam eleifend aliquet.',
          _react2.default.createElement('br', null),
          _react2.default.createElement('br', null),
          'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Phasellus consequat, massa posuere eleifend tincidunt, erat velit malesuada orci, sit amet vehicula tortor eros vel ipsum. Integer bibendum nunc eu eros blandit gravida. Aliquam erat volutpat. Phasellus non orci tristique, porttitor elit non, luctus augue. Vestibulum a aliquam quam. Proin eget orci ante. Phasellus viverra, erat sed sagittis ornare, Donec maximus elementum urna, egestas ultrices neque cursus vitae. Nullam rutrum libero erat. enim laoreet vel. Donec venenatis lacus ut tellus pharetra, a molestie lorem varius.',
          _react2.default.createElement('br', null),
          _react2.default.createElement('br', null),
          'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Phasellus consequat, massa posuere eleifend tincidunt, erat velit malesuada orci, sit amet vehicula tortor eros vel ipsum. Integer bibendum nunc eu eros blandit gravida. Aliquam erat volutpat. Phasellus non orci tristique, porttitor elit non, luctus augue. Vestibulum a aliquam quam. Proin eget orci ante. Phasellus viverra, erat sed sagittis ornare, Donec maximus elementum urna, egestas ultrices neque cursus vitae. Nullam rutrum libero erat. enim laoreet vel. Donec venenatis lacus ut tellus pharetra, a molestie lorem varius.'
        ),
        _react2.default.createElement(
          'div',
          { id: 'tab3' },
          'Nullam vel neque laoreet, interdum est eu, semper dui. Aliquam pretium urna vel mauris porttitor, in cursus dolor condimentum. Aliquam vitae faucibus nunc. Phasellus eleifend, ipsum quis auctor luctus, est nibh euismod odio, eu luctus lacus orci ac tellus. Donec pretium elit sapien, sit amet lobortis risus finibus bibendum. Ut feugiat mollis quam a fringilla. Curabitur vitae neque quis diam eleifend aliquet.',
          _react2.default.createElement('br', null),
          _react2.default.createElement('br', null),
          'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Phasellus consequat, massa posuere eleifend tincidunt, erat velit malesuada orci, sit amet vehicula tortor eros vel ipsum. Integer bibendum nunc eu eros blandit gravida. Aliquam erat volutpat. Phasellus non orci tristique, porttitor elit non, luctus augue. Vestibulum a aliquam quam. Proin eget orci ante. Phasellus viverra, erat sed sagittis ornare, Donec maximus elementum urna, egestas ultrices neque cursus vitae. Nullam rutrum libero erat. enim laoreet vel. Donec venenatis lacus ut tellus pharetra, a molestie lorem varius. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Phasellus consequat, massa posuere eleifend tincidunt, erat velit malesuada orci, sit amet vehicula tortor eros vel ipsum. Integer bibendum nunc eu eros blandit gravida. Aliquam erat volutpat. Phasellus non orci tristique, porttitor elit non, luctus augue. Vestibulum a aliquam quam. Proin eget orci ante. Phasellus viverra, erat sed sagittis ornare, Donec maximus elementum urna, egestas ultrices neque cursus vitae. Nullam rutrum libero erat. enim laoreet vel. Donec venenatis lacus ut tellus pharetra, a molestie lorem varius.'
        )
      )
    ),
    _react2.default.createElement(
      _index2.default,
      null,
      _react2.default.createElement(
        TabsContainer,
        null,
        _react2.default.createElement(
          Tab,
          { selected: true },
          'Tab 1'
        ),
        _react2.default.createElement(
          Tab,
          null,
          'Tab 2'
        )
      ),
      _react2.default.createElement(
        Content,
        null,
        'Content'
      )
    ),
    _react2.default.createElement(
      _index2.default,
      null,
      _react2.default.createElement(
        TabsContainer,
        null,
        _react2.default.createElement(
          Tab,
          { component: 'span', selected: true },
          'Tab 1'
        ),
        _react2.default.createElement(
          Tab,
          { component: 'span' },
          'Tab 2'
        )
      ),
      _react2.default.createElement(
        Content,
        null,
        'Content'
      )
    )
  )).toJSON();
  expect(tree).toMatchSnapshot();
});