'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactTextareaAutosize = require('react-textarea-autosize');

var _reactTextareaAutosize2 = _interopRequireDefault(_reactTextareaAutosize);

var _FieldControl = require('../FieldControl');

var _FieldControl2 = _interopRequireDefault(_FieldControl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function getInputProps(props) {
  var input = props.input,
      resultProps = _objectWithoutProperties(props, ['input']);

  return _extends({}, resultProps, input);
}

var propTypes = {
  textareaClassName: _propTypes2.default.string,
  input: _propTypes2.default.object
};

var defaultProps = {
  textareaClassName: '',
  input: null
};

var TextArea = function TextArea(_ref) {
  var textareaClassName = _ref.textareaClassName,
      props = _objectWithoutProperties(_ref, ['textareaClassName']);

  var _ref2 = props.input || props,
      value = _ref2.value;

  var length = typeof value === 'string' ? value.length : 0;
  return _react2.default.createElement(
    _FieldControl2.default,
    _extends({ length: length }, props),
    function (restProps) {
      return _react2.default.createElement(_reactTextareaAutosize2.default, _extends({
        className: (textareaClassName ? textareaClassName + ' ' : '') + 'flive_text-area_input-control'
      }, getInputProps(restProps)));
    }
  );
};

TextArea.propTypes = propTypes;
TextArea.defaultProps = defaultProps;
exports.default = TextArea;
module.exports = exports['default'];