'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FieldControl = require('../FieldControl');

var _FieldControl2 = _interopRequireDefault(_FieldControl);

var _tools = require('../_helpers/tools');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  value: _propTypes2.default.string,
  prefix: _propTypes2.default.string,
  input: _propTypes2.default.object
};

var defaultProps = {
  value: '',
  prefix: '',
  input: null
};

/**
 * Text Input
 *
 */

var TextInput = function (_React$PureComponent) {
  _inherits(TextInput, _React$PureComponent);

  function TextInput() {
    _classCallCheck(this, TextInput);

    return _possibleConstructorReturn(this, (TextInput.__proto__ || Object.getPrototypeOf(TextInput)).apply(this, arguments));
  }

  _createClass(TextInput, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          prefix = _props.prefix,
          props = _objectWithoutProperties(_props, ['prefix']);

      var _ref = props.input || props,
          value = _ref.value;

      var length = typeof value === 'string' ? value.length : 0;
      return _react2.default.createElement(
        _FieldControl2.default,
        _extends({ length: length }, props),
        function (restProps) {
          var inputResult = _react2.default.createElement('input', _extends({
            className: 'flive_text-input_input-control',
            maxLength: props.maxLength
          }, (0, _tools.getInputProps)(restProps)));
          return prefix ? _react2.default.createElement(
            'div',
            { className: 'flive_text-input_input-group' },
            prefix && _react2.default.createElement(
              'span',
              { className: 'flive_text-input_input-group-addon' },
              ' ',
              prefix,
              ' '
            ),
            inputResult
          ) : inputResult;
        }
      );
    }
  }]);

  return TextInput;
}(_react2.default.PureComponent);

TextInput.propTypes = propTypes;
TextInput.defaultProps = defaultProps;
exports.default = TextInput;
module.exports = exports['default'];