'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toasterReducer = exports.ToasterEventEmitter = undefined;

var _reactReduxToastr = require('react-redux-toastr');

Object.defineProperty(exports, 'ToasterEventEmitter', {
  enumerable: true,
  get: function get() {
    return _reactReduxToastr.toastr;
  }
});
Object.defineProperty(exports, 'toasterReducer', {
  enumerable: true,
  get: function get() {
    return _reactReduxToastr.reducer;
  }
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactReduxToastr2 = _interopRequireDefault(_reactReduxToastr);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Toaster = function Toaster(_ref) {
  var timeOut = _ref.timeOut,
      newestOnTop = _ref.newestOnTop,
      preventDuplicates = _ref.preventDuplicates,
      position = _ref.position,
      transitionIn = _ref.transitionIn,
      transitionOut = _ref.transitionOut,
      progressBar = _ref.progressBar,
      icon = _ref.icon,
      component = _ref.component,
      confirmOptions = _ref.confirmOptions;
  return _react2.default.createElement(_reactReduxToastr2.default, {
    timeOut: timeOut,
    newestOnTop: newestOnTop,
    preventDuplicates: preventDuplicates,
    position: position,
    transitionIn: transitionIn,
    transitionOut: transitionOut,
    progressBar: progressBar,
    component: component,
    icon: icon,
    confirmOptions: confirmOptions
  });
};

Toaster.propTypes = {
  timeOut: _propTypes2.default.number,
  newestOnTop: _propTypes2.default.bool,
  preventDuplicates: _propTypes2.default.bool,
  position: _propTypes2.default.string,
  transitionIn: _propTypes2.default.string,
  transitionOut: _propTypes2.default.string,
  progressBar: _propTypes2.default.bool,
  icon: _propTypes2.default.node,
  component: _propTypes2.default.node,
  confirmOptions: _propTypes2.default.object
};

Toaster.defaultProps = {
  timeOut: 2000,
  newestOnTop: true,
  preventDuplicates: false,
  position: 'bottom-right',
  transitionIn: 'fadeIn',
  transitionOut: 'fadeOut',
  progressBar: false,
  icon: null,
  component: null,
  confirmOptions: {}
};

exports.default = Toaster;