'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _rcTooltip = require('rc-tooltip');

var _rcTooltip2 = _interopRequireDefault(_rcTooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tooltip = function (_PureComponent) {
  _inherits(Tooltip, _PureComponent);

  function Tooltip() {
    _classCallCheck(this, Tooltip);

    return _possibleConstructorReturn(this, (Tooltip.__proto__ || Object.getPrototypeOf(Tooltip)).apply(this, arguments));
  }

  _createClass(Tooltip, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          trigger = _props.trigger,
          placement = _props.placement,
          overlay = _props.overlay,
          children = _props.children,
          mouseEnterDelay = _props.mouseEnterDelay,
          mouseLeaveDelay = _props.mouseLeaveDelay,
          Component = _props.component,
          className = _props.className,
          overlayClassName = _props.overlayClassName,
          rest = _objectWithoutProperties(_props, ['trigger', 'placement', 'overlay', 'children', 'mouseEnterDelay', 'mouseLeaveDelay', 'component', 'className', 'overlayClassName']);

      return _react2.default.createElement(
        _rcTooltip2.default,
        _extends({
          trigger: trigger,
          mouseEnterDelay: mouseEnterDelay,
          placement: placement,
          mouseLeaveDelay: mouseLeaveDelay,
          overlay: overlay,
          overlayClassName: overlayClassName
        }, rest),
        _react2.default.createElement(
          Component,
          _extends({ className: className }, rest),
          children
        )
      );
    }
  }]);

  return Tooltip;
}(_react.PureComponent);

Tooltip.propTypes = {
  trigger: _propTypes2.default.arrayOf(_propTypes2.default.string),
  placement: _propTypes2.default.string,
  children: _propTypes2.default.node,
  overlay: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.string]),
  component: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object, _propTypes2.default.func]),
  mouseEnterDelay: _propTypes2.default.number,
  mouseLeaveDelay: _propTypes2.default.number,
  className: _propTypes2.default.string,
  overlayClassName: _propTypes2.default.string
};
Tooltip.defaultProps = {
  trigger: ['hover'],
  component: 'span',
  placement: 'top',
  overlay: null,
  children: null,
  mouseEnterDelay: 0.15,
  mouseLeaveDelay: 0.15,
  className: undefined,
  overlayClassName: undefined
};
exports.default = Tooltip;
module.exports = exports['default'];