'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.isTouchDevice = isTouchDevice;
exports.capitalizeFirstLetter = capitalizeFirstLetter;
exports.isDataURL = isDataURL;
exports.getInputProps = getInputProps;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function isTouchDevice() {
  return !!((typeof window === 'undefined' ? 'undefined' : _typeof(window)) === 'object' && (window.ontouchstart || navigator.maxTouchPoints));
}

function capitalizeFirstLetter(value) {
  return value.charAt(0).toUpperCase() + value.slice(1);
}

// got from https://gist.github.com/bgrins/6194623
function isDataURL(s) {
  return !!s.match(isDataURL.regex);
}
isDataURL.regex = /^\s*data:([a-z]+\/[a-z]+(;[a-z\-]+\=[a-z\-]+)?)?(;base64)?,[a-z0-9\!\$\&\'\,\(\)\*\+\,\;\=\-\.\_\~\:\@\/\?\%\s]*\s*$/i; // eslint-disable-line

function getInputProps(props) {
  var input = props.input,
      resultProps = _objectWithoutProperties(props, ['input']);

  return _extends({}, resultProps, input);
}

var createFakeEvent = exports.createFakeEvent = function createFakeEvent(value) {
  return {
    target: { value: value },
    stopPropagation: function stopPropagation(x) {
      return x;
    },
    preventDefault: function preventDefault(x) {
      return x;
    }
  };
};