import React from 'react';
import renderer from 'react-test-renderer'; // eslint-disable-line import/no-extraneous-dependencies

import BreadCrumb from './index';

const { Item } = BreadCrumb;

test('BreadCrumb renders correctly', () => {
  const tree = renderer.create(
    <div>
      <BreadCrumb variant="night-blue">
        <Item component="a" href="/">Home</Item>
        <Item component="a" href="/news">News</Item>
        <Item href="/news">Press Room</Item>
      </BreadCrumb>
      <BreadCrumb variant="white" style={{ background: '#000' }}>
        <Item component="a" href="/">Home</Item>
        <Item component="a" href="/news">News</Item>
        <Item href="/news">Press Room</Item>
      </BreadCrumb>
    </div>
  ).toJSON();
  expect(tree).toMatchSnapshot();
});
