import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import './card-body.scss';

const SectionBody = ({ className, colorVariant, section, size, ...props }) => (
  <div
    className={className}
    styleName={classNames(
      'body-container', colorVariant, { section }
    )}
    {...props}
  />
);

SectionBody.propTypes = {
  /** @ignore */
  className: PropTypes.string,
  colorVariant: PropTypes.string,
  section: PropTypes.bool,
  size: PropTypes.string
};

SectionBody.defaultProps = {
  className: undefined,
  colorVariant: 'grey',
  section: false,
  size: 'md'
};

SectionBody.componentName = 'CardSectionBody';

export default SectionBody;
