import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import './card-footer.scss';

const SectionFooter = ({ colorVariant, className, left, separator, ...props }) => (
  <div
    className={className}
    styleName={classNames(
      `footer footer--${colorVariant}`,
      { 'footer--left': left },
      { 'footer--separator': separator }
    )}
    {...props}
  />
);

SectionFooter.propTypes = {
  /** @ignore */
  className: PropTypes.string,
  colorVariant: PropTypes.string,
  left: PropTypes.bool,
  separator: PropTypes.bool
};

SectionFooter.defaultProps = {
  className: null,
  colorVariant: 'grey',
  left: false,
  separator: false
};

SectionFooter.componentName = 'CardSectionFooter';

export default SectionFooter;
