import React from 'react';
import PropTypes from 'prop-types';
import classnames from 'classnames';

import './fieldset.scss';


const Fieldset = ({ legend, legendPosition, children }) => (
  <fieldset
    styleName={classnames({
      [legendPosition]: legendPosition,
      fieldset: true
    })}
  >
    { legend && <legend>{ legend }</legend> }
    { children }
  </fieldset>
);


Fieldset.propTypes = {
  legend: PropTypes.string,
  legendPosition: PropTypes.oneOf([
    'top-left',
    'top-right',
    'bottom-left',
    'bottom-right'
  ]),
  children: PropTypes.oneOfType([
    PropTypes.element,
    PropTypes.node,
    PropTypes.func
  ])
};

Fieldset.defaultProps = {
  legend: null,
  legendPosition: 'top-left',
  children: null
};

export default Fieldset;
