import React from 'react';
import renderer from 'react-test-renderer'; // eslint-disable-line import/no-extraneous-dependencies

import FilterBar from './index';

test('FilterBar renders correctly', () => {
  const baseOptions = [
    {
      value: 'country',
      label: 'Country',
      subOptions: [
        { label: 'FR', value: 'fr' },
        { label: 'US', value: 'us' },
        { label: 'ES', value: 'es' }
      ]
    }
  ];
  const tree = renderer.create(
    <div>
      <FilterBar
        value={{}}
        baseOptions={baseOptions}
        onChange={() => {}}
      />
    </div>
  ).toJSON();
  expect(tree).toMatchSnapshot();
});

test('FilterBar renders correctly with initial values', () => {
  const baseOptions = [
    {
      value: 'country',
      label: 'Country',
      subOptions: [
        { label: 'FR', value: 'fr' },
        { label: 'US', value: 'us' },
        { label: 'ES', value: 'es' }
      ]
    }
  ];
  const tree = renderer.create(
    <div>
      <FilterBar
        value={{ country: 'fr' }}
        baseOptions={baseOptions}
        onChange={() => {}}
      />
    </div>
  ).toJSON();
  expect(tree).toMatchSnapshot();
});
