import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';

import './buttons-wrapper.scss';

const propTypes = {
  align: PropTypes.oneOf(['left', 'center', 'right']),
  className: PropTypes.string
};

const defaultProps = {
  align: 'left',
  className: undefined
};

const ButtonsWrapper = ({
   align, className, ...props
}) => <div className={className} styleName={classNames('base', align)} {...props} />;

ButtonsWrapper.propTypes = propTypes;
ButtonsWrapper.defaultProps = defaultProps;

export default ButtonsWrapper;
