import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';

import styles from './layout-wrapper.scss'; // eslint-disable-line no-unused-vars
import fliveGlobal from '../_assets/style/flive-global.scss'; // eslint-disable-line no-unused-vars

class LayoutWrapper extends PureComponent {
  static propTypes = {
    /** @ignore */
    className: PropTypes.string
  }

  static defaultProps = {
    className: undefined
  }

  static childContextTypes = {
    layout: PropTypes.object
  }

  getChildContext = () => ({
    layout: this
  })

  config = {}

  register = (element, newConfig) => {
    this.config[element] = newConfig;
  };

  render() {
    const { className, ...props } = this.props;
    return <div className={className} styleName="styles.base" {...props} />;
  }
}

export default LayoutWrapper;
