import React from 'react';
import PropTypes from 'prop-types';

import './nav-item-wrapper.scss';

const propTypes = {
  /** @ignore */
  className: PropTypes.string,
  component: PropTypes.oneOfType([
    PropTypes.string,
    PropTypes.object,
    PropTypes.func
  ])
};

const defaultProps = {
  className: undefined,
  component: 'div'
};

const ItemWrapper = ({ className, component: Component, ...props }) => (
  <Component className={className} styleName="base" {...props} />
);

ItemWrapper.propTypes = propTypes;
ItemWrapper.defaultProps = defaultProps;

export default ItemWrapper;
