import React from 'react';
import PropTypes from 'prop-types';

import './progress.scss';

const propTypes = {
  value: PropTypes.string,
  total: PropTypes.string,
  showPercentage: PropTypes.bool,
  className: PropTypes.string
};

const defaultProps = {
  value: 0,
  total: 100,
  showPercentage: true,
  className: null
};

/**
 * Progress bar
 */
const Progress = props => {
  const { className, value, total, showPercentage, ...rest } = props;
  const percentage = `${Math.floor((parseInt(value, 10) / parseInt(total, 10)) * 100)}%`;

  return (
    <div styleName="container">
      <div
        className={className}
        styleName="progress" {...rest}
        style={{
          width: showPercentage ? '95%' : '100%'
        }}
      >
        <div
          styleName="bar"
          style={{
            width: percentage
          }}
        />
      </div>
      <span styleName="percentage" style={{ display: showPercentage ? 'inline-block' : 'none' }}>{percentage}</span>
    </div>
  );
};


Progress.propTypes = propTypes;
Progress.defaultProps = defaultProps;
Progress.componentName = 'Progress';

export default Progress;
