import React from 'react';
import PropTypes from 'prop-types';
import Button from '../../Button';

const SlideNext = ({ size, variant, currentSlide, slideCount, goToSlide }) => {
  const onSlide = e => {
    e.preventDefault();
    goToSlide(currentSlide + 1);
  };
  return (
    <Button onClick={onSlide} disabled={currentSlide + 1 === slideCount} {...{ size, variant }}>
      Next
    </Button>
  );
};

SlideNext.propTypes = {
  size: PropTypes.string,
  variant: PropTypes.string,
  currentSlide: PropTypes.number,
  slideCount: PropTypes.number,
  goToSlide: PropTypes.func
};

SlideNext.defaultProps = {
  size: 'lg',
  variant: 'dash-lagoon',
  currentSlide: 0,
  slideCount: 0,
  goToSlide: null
};

export default SlideNext;
